//  -*- Mode: Java -*-
//
// /tmp/build-stella/stella-3.0.0.beta/native/java/edu/isi/stella/StartupDateTimeParser.java

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/

package edu.isi.stella;

import edu.isi.stella.javalib.*;

public class StartupDateTimeParser {
  static void helpStartupDateTimeParser1() {
    {
      Stella.SYM_STELLA_FOREACH = ((Symbol)(Stella.internRigidSymbolWrtModule("FOREACH", null, 0)));
      Stella.SYM_STELLA_ITEM = ((Symbol)(Stella.internRigidSymbolWrtModule("ITEM", null, 0)));
      Stella.SYM_STELLA_DO = ((Symbol)(Stella.internRigidSymbolWrtModule("DO", null, 0)));
      Stella.SYM_STELLA_INSERT_AT = ((Symbol)(Stella.internRigidSymbolWrtModule("INSERT-AT", null, 0)));
      Stella.SYM_STELLA_SECOND = ((Symbol)(Stella.internRigidSymbolWrtModule("SECOND", null, 0)));
      Stella.SYM_STELLA_HASHLIST = ((Symbol)(Stella.internRigidSymbolWrtModule("HASHLIST", null, 0)));
      Stella.SYM_STELLA_HASHLIST_EXPANDER = ((Symbol)(Stella.internRigidSymbolWrtModule("HASHLIST-EXPANDER", null, 0)));
      Stella.SYM_STELLA_AM = ((Symbol)(Stella.internRigidSymbolWrtModule("AM", null, 0)));
      Stella.SYM_STELLA_PM = ((Symbol)(Stella.internRigidSymbolWrtModule("PM", null, 0)));
      Stella.SYM_STELLA_NOON = ((Symbol)(Stella.internRigidSymbolWrtModule("NOON", null, 0)));
      Stella.SYM_STELLA_MIDN = ((Symbol)(Stella.internRigidSymbolWrtModule("MIDN", null, 0)));
      Stella.SYM_STELLA_MONTH = ((Symbol)(Stella.internRigidSymbolWrtModule("MONTH", null, 0)));
      Stella.SYM_STELLA_WEEKDAY = ((Symbol)(Stella.internRigidSymbolWrtModule("WEEKDAY", null, 0)));
      Stella.SYM_STELLA_AM_PM = ((Symbol)(Stella.internRigidSymbolWrtModule("AM-PM", null, 0)));
      Stella.SYM_STELLA_NOON_MIDN = ((Symbol)(Stella.internRigidSymbolWrtModule("NOON-MIDN", null, 0)));
      Stella.SYM_STELLA_ZONE = ((Symbol)(Stella.internRigidSymbolWrtModule("ZONE", null, 0)));
      Stella.SYM_STELLA_TIME_DIVIDER = ((Symbol)(Stella.internRigidSymbolWrtModule("TIME-DIVIDER", null, 0)));
      Stella.SYM_STELLA_DATE_DIVIDER = ((Symbol)(Stella.internRigidSymbolWrtModule("DATE-DIVIDER", null, 0)));
      Stella.SYM_STELLA_SECONDP = ((Symbol)(Stella.internRigidSymbolWrtModule("SECONDP", null, 0)));
      Stella.SYM_STELLA_MINUTE = ((Symbol)(Stella.internRigidSymbolWrtModule("MINUTE", null, 0)));
      Stella.SYM_STELLA_HOUR = ((Symbol)(Stella.internRigidSymbolWrtModule("HOUR", null, 0)));
      Stella.SYM_STELLA_DAY = ((Symbol)(Stella.internRigidSymbolWrtModule("DAY", null, 0)));
      Stella.SYM_STELLA_YEAR = ((Symbol)(Stella.internRigidSymbolWrtModule("YEAR", null, 0)));
      Stella.SYM_STELLA_STARTUP_DATE_TIME_PARSER = ((Symbol)(Stella.internRigidSymbolWrtModule("STARTUP-DATE-TIME-PARSER", null, 0)));
    }
  }

  public static void startupDateTimeParser() {
    { Object old$Module$000 = Stella.$MODULE$.get();
      Object old$Context$000 = Stella.$CONTEXT$.get();

      try {
        edu.isi.stella.javalib.Native.setSpecial(Stella.$MODULE$, Stella.$STELLA_MODULE$);
        edu.isi.stella.javalib.Native.setSpecial(Stella.$CONTEXT$, ((Module)(Stella.$MODULE$.get())));
        if (Stella.currentStartupTimePhaseP(2)) {
          StartupDateTimeParser.helpStartupDateTimeParser1();
        }
        if (Stella.currentStartupTimePhaseP(4)) {
          Stella.WHITESPACE_CHARS = Stella.getQuotedTree("((#\\  #\\Tab #\\Linefeed #\\, #\\' #\\`) \"/STELLA\")", "/STELLA");
          Stella.TIME_DIVIDERS = Stella.getQuotedTree("((#\\: #\\.) \"/STELLA\")", "/STELLA");
          Stella.DATE_DIVIDERS = Stella.getQuotedTree("((#\\\\ #\\/ #\\-) \"/STELLA\")", "/STELLA");
          edu.isi.stella.javalib.Native.setBooleanSpecial(Stella.$ERROR_ON_MISMATCH$, Stella.FALSE);
          edu.isi.stella.javalib.Native.setSpecial(Stella.$WEEKDAY_STRINGS$, StringHashTable.newStringHashTable());
          edu.isi.stella.javalib.Native.setSpecial(Stella.$MONTH_STRINGS$, StringToIntegerHashTable.newStringToIntegerHashTable());
          edu.isi.stella.javalib.Native.setSpecial(Stella.$ZONE_STRINGS$, StringHashTable.newStringHashTable());
          edu.isi.stella.javalib.Native.setSpecial(Stella.$SPECIAL_STRINGS$, StringHashTable.newStringHashTable());
          edu.isi.stella.javalib.Native.setSpecial(Stella.$SPECIAL_SYMBOLS$, Stella.getQuotedTree("((YESTERDAY TODAY TOMORROW NOW) \"/STELLA\")", "/STELLA"));
          { Cons item = null;
            Cons iter040 = ((Cons)(Stella.getQuotedTree("(((\"monday\" :MONDAY) (\"mon\" :MONDAY) (\"tuesday\" :TUESDAY) (\"tues\" :TUESDAY) (\"tue\" :TUESDAY) (\"wednesday\" :WEDNESDAY) (\"wednes\" :WEDNESDAY) (\"wed\" :WEDNESDAY) (\"thursday\" :THURSDAY) (\"thurs\" :THURSDAY) (\"thu\" :THURSDAY) (\"friday\" :FRIDAY) (\"fri\" :FRIDAY) (\"saturday\" :SATURDAY) (\"sat\" :SATURDAY) (\"sunday\" :SUNDAY) (\"sun\" :SUNDAY)) \"/STELLA\")", "/STELLA")));

            while (!(iter040 == Stella.NIL)) {
              {
                item = ((Cons)(iter040.value));
                iter040 = iter040.rest;
              }
              ((StringHashTable)(Stella.$WEEKDAY_STRINGS$.get())).insertAt(((StringWrapper)(item.value)).wrapperValue, item.rest.value);
            }
          }
          { Cons item = null;
            Cons iter041 = ((Cons)(Stella.getQuotedTree("(((\"january\" 1) (\"jan\" 1) (\"february\" 2) (\"feb\" 2) (\"march\" 3) (\"mar\" 3) (\"april\" 4) (\"apr\" 4) (\"may\" 5) (\"june\" 6) (\"jun\" 6) (\"july\" 7) (\"jul\" 7) (\"august\" 8) (\"aug\" 8) (\"september\" 9) (\"sept\" 9) (\"sep\" 9) (\"october\" 10) (\"oct\" 10) (\"november\" 11) (\"nov\" 11) (\"december\" 12) (\"dec\" 12)) \"/STELLA\")", "/STELLA")));

            while (!(iter041 == Stella.NIL)) {
              {
                item = ((Cons)(iter041.value));
                iter041 = iter041.rest;
              }
              ((StringToIntegerHashTable)(Stella.$MONTH_STRINGS$.get())).insertAt(((StringWrapper)(item.value)).wrapperValue, ((IntegerWrapper)(item.rest.value)).wrapperValue);
            }
          }
          { Cons item = null;
            Cons iter042 = ((Cons)(Stella.getQuotedTree("(((\"gmt\" 0.0) (\"utc\" 0.0) (\"est\" -5.0) (\"edt\" -4.0) (\"cst\" -6.0) (\"cdt\" -5.0) (\"mst\" -7.0) (\"mdt\" -6.0) (\"pst\" -8.0) (\"pdt\" -7.0) (\"A\" 1.0) (\"B\" 2.0) (\"C\" 3.0) (\"C*\" 3.5) (\"D\" 4.0) (\"D*\" 4.5) (\"E\" 5.0) (\"E*\" 4.5) (\"F\" 6.0) (\"F*\" 6.5) (\"G\" 7.0) (\"H\" 7.0) (\"I\" 9.0) (\"I*\" 9.5) (\"K\" 10.0) (\"K*\" 10.5) (\"L\" 11.0) (\"L*\" 11.5) (\"M\" 12.0) (\"N\" -1.0) (\"O\" -2.0) (\"P\" -3.0) (\"P*\" -3.5) (\"Q\" -4.0) (\"R\" -5.0) (\"S\" -6.0) (\"T\" -7.0) (\"U\" -8.0) (\"U*\" -8.5) (\"V\" -9.0) (\"V*\" -9.5) (\"W\" -10.0) (\"X\" -11.0) (\"Y\" -12.0) (\"Z\" 0.0)) \"/STELLA\")", "/STELLA")));

            while (!(iter042 == Stella.NIL)) {
              {
                item = ((Cons)(iter042.value));
                iter042 = iter042.rest;
              }
              ((StringHashTable)(Stella.$ZONE_STRINGS$.get())).insertAt(((StringWrapper)(item.value)).wrapperValue, item.rest.value);
            }
          }
          { Symbol symbol = null;
            Cons iter043 = ((Cons)(Stella.$SPECIAL_SYMBOLS$.get()));

            while (!(iter043 == Stella.NIL)) {
              {
                symbol = ((Symbol)(iter043.value));
                iter043 = iter043.rest;
              }
              ((StringHashTable)(Stella.$SPECIAL_STRINGS$.get())).insertAt(Native.stringDowncase(symbol.symbolName), symbol);
            }
          }
          edu.isi.stella.javalib.Native.setSpecial(Stella.$DATE_TIME_PATTERNS$, Stella.getQuotedTree("(((YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY (NOON-MIDN)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR (NOON-MIDN) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR (NOON-MIDN) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (NOON-MIDN) (DATE-DIVIDER) (ZONE)) (MONTH (DATE-DIVIDER) YEAR (NOON-MIDN) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH (NOON-MIDN) (DATE-DIVIDER) (ZONE)) ((NOON-MIDN) (WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR) ((NOON-MIDN) (WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR) ((NOON-MIDN) (WEEKDAY) MONTH (DATE-DIVIDER) DAY) ((NOON-MIDN) YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY) ((NOON-MIDN) MONTH (DATE-DIVIDER) YEAR) ((NOON-MIDN) YEAR (DATE-DIVIDER) MONTH) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (NOON-MIDN (DATE-DIVIDER) (ZONE)) (HOUR (NOON-MIDN)) (YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY NOON-MIDN (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY NOW) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (MONTH (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) (WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) (WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) (WEEKDAY) MONTH (DATE-DIVIDER) DAY) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) MONTH (DATE-DIVIDER) YEAR) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) YEAR (DATE-DIVIDER) MONTH) (WEEKDAY MONTH DAY HOUR (TIME-DIVIDER) MINUTE (TIME-DIVIDER) SECONDP (AM-PM) (ZONE) YEAR) ((WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) MINUTE (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) MINUTE (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) (MONTH)) (MONTH (DATE-DIVIDER) (YEAR)) ((WEEKDAY) MONTH DAY HOUR TIME-DIVIDER MINUTE (TIME-DIVIDER) (SECONDP) YEAR) (NOW (YESTERDAY)) ((YESTERDAY) NOW) (NOW (TODAY)) ((TODAY) NOW) (NOW (TOMORROW)) ((TOMORROW) NOW) (YESTERDAY (NOON-MIDN)) ((NOON-MIDN) YESTERDAY) (TODAY (NOON-MIDN)) ((NOON-MIDN) TODAY) (TOMORROW (NOON-MIDN)) ((NOON-MIDN) TOMORROW) (YESTERDAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (TOMORROW HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (TODAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE))) \"/STELLA\")", "/STELLA"));
        }
        if (Stella.currentStartupTimePhaseP(6)) {
          Stella.finalizeClasses();
        }
        if (Stella.currentStartupTimePhaseP(7)) {
          Stella.defineFunctionObject("HASHLIST-EXPANDER", "(DEFUN (HASHLIST-EXPANDER OBJECT) ((LIST (CONS OF CONS)) (TABLE HASH-TABLE)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Cons", "hashlistExpander", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.HashTable")}), null);
          Stella.defineFunctionObject("YESTERDAY", "(DEFUN YESTERDAY ((PARSED-VALUES DECODED-DATE-TIME)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.DecodedDateTime", "yesterday", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.DecodedDateTime")}), null);
          Stella.defineFunctionObject("TODAY", "(DEFUN TODAY ((PARSED-VALUES DECODED-DATE-TIME)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.DecodedDateTime", "today", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.DecodedDateTime")}), null);
          Stella.defineFunctionObject("TOMORROW", "(DEFUN TOMORROW ((PARSED-VALUES DECODED-DATE-TIME)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.DecodedDateTime", "tomorrow", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.DecodedDateTime")}), null);
          Stella.defineFunctionObject("NOW", "(DEFUN NOW ((PARSED-VALUES DECODED-DATE-TIME)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.DecodedDateTime", "now", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.DecodedDateTime")}), null);
          Stella.defineFunctionObject("AM-PM", "(DEFUN (AM-PM SYMBOL) ((STRING OBJECT)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "amPm", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
          Stella.defineFunctionObject("NOON-MIDN", "(DEFUN (NOON-MIDN SYMBOL) ((STRING OBJECT)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "noonMidn", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
          Stella.defineFunctionObject("WEEKDAY", "(DEFUN (WEEKDAY KEYWORD) ((THING OBJECT)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "weekday", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
          Stella.defineFunctionObject("MONTH", "(DEFUN (MONTH INTEGER-WRAPPER) ((THING OBJECT)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "month", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
          Stella.defineFunctionObject("ZONE", "(DEFUN (ZONE FLOAT-WRAPPER) ((THING OBJECT)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "zone", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
          Stella.defineFunctionObject("SPECIALP", "(DEFUN (SPECIALP SYMBOL) ((STRING OBJECT)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "specialp", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
          Stella.defineFunctionObject("SECONDP", "(DEFUN (SECONDP BOOLEAN-WRAPPER) ((NUMBER OBJECT)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "secondp", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
          Stella.defineFunctionObject("MINUTE", "(DEFUN (MINUTE BOOLEAN-WRAPPER) ((NUMBER OBJECT)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "minute", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
          Stella.defineFunctionObject("HOUR", "(DEFUN (HOUR BOOLEAN-WRAPPER) ((NUMBER OBJECT)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "hour", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
          Stella.defineFunctionObject("DAY", "(DEFUN (DAY BOOLEAN-WRAPPER) ((NUMBER OBJECT)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "day", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
          Stella.defineFunctionObject("YEAR", "(DEFUN (YEAR BOOLEAN-WRAPPER) ((NUMBER OBJECT)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "year", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
          Stella.defineFunctionObject("TIME-DIVIDER", "(DEFUN (TIME-DIVIDER BOOLEAN-WRAPPER) ((THECHARACTER OBJECT)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "timeDivider", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
          Stella.defineFunctionObject("DATE-DIVIDER", "(DEFUN (DATE-DIVIDER BOOLEAN-WRAPPER) ((THECHARACTER OBJECT)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "dateDivider", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
          Stella.defineFunctionObject("MATCH-SUBSTRING", "(DEFUN (MATCH-SUBSTRING CONS) ((SUBSTRING STRING)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "matchSubstring", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String")}), null);
          Stella.defineFunctionObject("DIGIT-VALUE", "(DEFUN (DIGIT-VALUE INTEGER) ((CHAR CHARACTER)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "digitValue", new java.lang.Class [] {java.lang.Character.TYPE}), null);
          Stella.defineFunctionObject("DECOMPOSE-DATE-TIME-STRING", "(DEFUN (DECOMPOSE-DATE-TIME-STRING CONS) ((STRING STRING) (START INTEGER) (END INTEGER)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "decomposeDateTimeString", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String"), java.lang.Integer.TYPE, java.lang.Integer.TYPE}), null);
          Stella.defineFunctionObject("MATCH-PATTERN-ELEMENT", "(DEFUN (MATCH-PATTERN-ELEMENT CONS) ((PATTERN-ELEMENT SYMBOL) (DATUM-ELEMENT OBJECT)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Symbol", "matchPatternElement", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Symbol"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
          Stella.defineFunctionObject("MATCH-PATTERN", "(DEFUN (MATCH-PATTERN CONS) ((PATTERN CONS) (DATUM CONS) (DATUM-LENGTH INTEGER)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Cons", "matchPattern", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons"), java.lang.Integer.TYPE}), null);
          Stella.defineFunctionObject("DEAL-WITH-NOON-MIDN", "(DEFUN DEAL-WITH-NOON-MIDN ((FORM-VALUE OBJECT) (PARSED-VALUES DECODED-DATE-TIME)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "dealWithNoonMidn", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.DecodedDateTime")}), null);
          Stella.defineFunctionObject("DEAL-WITH-AM-PM", "(DEFUN DEAL-WITH-AM-PM ((FORM-VALUE OBJECT) (PARSED-VALUES DECODED-DATE-TIME)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "dealWithAmPm", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.DecodedDateTime")}), null);
          Stella.defineFunctionObject("SET-TIME-VALUES", "(DEFUN SET-TIME-VALUES ((STRING-FORM (CONS OF CONS)) (PARSED-VALUES DECODED-DATE-TIME)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Cons", "setTimeValues", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.DecodedDateTime")}), null);
          Stella.defineFunctionObject("PARSE-DATE-TIME", "(DEFUN (PARSE-DATE-TIME DECODED-DATE-TIME) ((DATE-TIME-STRING STRING) (START INTEGER) (END INTEGER) (ERROR-ON-MISMATCH? BOOLEAN)) :PUBLIC? TRUE :DOCUMENTATION \"Tries very hard to make sense out of the argument `date-time-string' and\nreturns a time structure if successful.  If not, it returns `null'.\nIf `error-on-mismatch?' is true, parse-date-time will signal an error instead of\nreturning `null'.  \nDefault values are 00:00:00 UTC on the current date\")", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "parseDateTime", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String"), java.lang.Integer.TYPE, java.lang.Integer.TYPE, java.lang.Boolean.TYPE}), null);
          Stella.defineFunctionObject("STRING-TO-CALENDAR-DATE", "(DEFUN (STRING-TO-CALENDAR-DATE CALENDAR-DATE) ((INPUT STRING)) :PUBLIC? TRUE :DOCUMENTATION \"Returns a calendar date object representing the date and time\nparsed from the `input' string.  If no valid parse is found,\n`null' is returned.\")", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "stringToCalendarDate", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String")}), null);
          Stella.defineFunctionObject("STARTUP-DATE-TIME-PARSER", "(DEFUN STARTUP-DATE-TIME-PARSER () :PUBLIC? TRUE)", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.StartupDateTimeParser", "startupDateTimeParser", new java.lang.Class [] {}), null);
          { MethodSlot function = Symbol.lookupFunction(Stella.SYM_STELLA_STARTUP_DATE_TIME_PARSER);

            KeyValueList.setDynamicSlotValue(function.dynamicSlots, Stella.SYM_STELLA_METHOD_STARTUP_CLASSNAME, Stella.wrapString("Startup-Date-Time-Parser"), Stella.NULL_STRING_WRAPPER);
          }
        }
        if (Stella.currentStartupTimePhaseP(8)) {
          Stella.finalizeSlots();
          Stella.cleanupUnfinalizedClasses();
        }
        if (Stella.currentStartupTimePhaseP(9)) {
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFCONSTANT WHITESPACE-CHARS CONS (QUOTE (#\\  #\\Tab #\\Linefeed #\\, #\\' #\\`)))");
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFCONSTANT TIME-DIVIDERS CONS (QUOTE (#\\: #\\.)))");
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFCONSTANT DATE-DIVIDERS CONS (QUOTE (#\\\\ #\\/ #\\-)))");
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFSPECIAL *ERROR-ON-MISMATCH* BOOLEAN FALSE :PUBLIC? TRUE :DOCUMENTATION \"If TRUE, an error will be signalled if parse-date-time is unable\n   to determine the time/date format of the string.\")");
          Symbol.storeMacro(Stella.SYM_STELLA_HASHLIST, Stella.SYM_STELLA_HASHLIST_EXPANDER, edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Cons", "hashlistExpander", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.HashTable")}));
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFSPECIAL *WEEKDAY-STRINGS* (STRING-HASH-TABLE OF STRING KEYWORD) (NEW (STRING-HASH-TABLE OF STRING KEYWORD)))");
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFSPECIAL *MONTH-STRINGS* STRING-TO-INTEGER-HASH-TABLE (NEW STRING-TO-INTEGER-HASH-TABLE))");
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFSPECIAL *ZONE-STRINGS* (STRING-HASH-TABLE OF STRING FLOAT-WRAPPER) (NEW (STRING-HASH-TABLE OF STRING FLOAT-WRAPPER)))");
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFSPECIAL *SPECIAL-STRINGS* STRING-HASH-TABLE (NEW STRING-HASH-TABLE))");
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFSPECIAL *SPECIAL-SYMBOLS* (CONS OF SYMBOL) (QUOTE (YESTERDAY TODAY TOMORROW NOW)))");
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFSPECIAL *DATE-TIME-PATTERNS* CONS (QUOTE ((YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY (NOON-MIDN)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR (NOON-MIDN) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR (NOON-MIDN) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (NOON-MIDN) (DATE-DIVIDER) (ZONE)) (MONTH (DATE-DIVIDER) YEAR (NOON-MIDN) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH (NOON-MIDN) (DATE-DIVIDER) (ZONE)) ((NOON-MIDN) (WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR) ((NOON-MIDN) (WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR) ((NOON-MIDN) (WEEKDAY) MONTH (DATE-DIVIDER) DAY) ((NOON-MIDN) YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY) ((NOON-MIDN) MONTH (DATE-DIVIDER) YEAR) ((NOON-MIDN) YEAR (DATE-DIVIDER) MONTH) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (NOON-MIDN (DATE-DIVIDER) (ZONE)) (HOUR (NOON-MIDN)) (YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY NOON-MIDN (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY NOW) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (MONTH (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) (WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) (WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) (WEEKDAY) MONTH (DATE-DIVIDER) DAY) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) MONTH (DATE-DIVIDER) YEAR) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) YEAR (DATE-DIVIDER) MONTH) (WEEKDAY MONTH DAY HOUR (TIME-DIVIDER) MINUTE (TIME-DIVIDER) SECONDP (AM-PM) (ZONE) YEAR) ((WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) MINUTE (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) MINUTE (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) (MONTH)) (MONTH (DATE-DIVIDER) (YEAR)) ((WEEKDAY) MONTH DAY HOUR TIME-DIVIDER MINUTE (TIME-DIVIDER) (SECONDP) YEAR) (NOW (YESTERDAY)) ((YESTERDAY) NOW) (NOW (TODAY)) ((TODAY) NOW) (NOW (TOMORROW)) ((TOMORROW) NOW) (YESTERDAY (NOON-MIDN)) ((NOON-MIDN) YESTERDAY) (TODAY (NOON-MIDN)) ((NOON-MIDN) TODAY) (TOMORROW (NOON-MIDN)) ((NOON-MIDN) TOMORROW) (YESTERDAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (TOMORROW HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (TODAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)))))");
        }

      } finally {
        Stella.$CONTEXT$.set(old$Context$000);
        Stella.$MODULE$.set(old$Module$000);
      }
    }
  }

}
