// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/classes.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/


namespace stella {

// Class definitions:
class All_Class_Slots_Iterator : public Iterator {
public:
  Cons* iterator_cons_list;
  Object* iterator_object;
public:
  virtual boolean nextP();
  virtual Surrogate* primary_type();
};


// Global declarations:
extern DECLARE_STELLA_SPECIAL(oWARNIFREDEFINEpo, boolean );
extern List* oUNFINALIZED_CLASSESo;
extern boolean oNEWLY_UNFINALIZED_CLASSESpo;
extern List* oCLASSES_WITH_UNRESOLVED_CHILDREN_REFERENCESo;
extern int oSYMBOL_SLOT_OFFSET_COUNTERo;
extern int oSLOT_CACHE_SIZEo;
extern Taxonomy_Graph* oCLASS_TAXONOMY_GRAPHo;

// Function signatures:
char* class_name(Class* renamed_Class);
Symbol* class_symbol(Class* renamed_Class);
Class* string_lookup_class(char* name);
Class* type_to_class(Surrogate* type);
Class* string_get_stella_class(char* class_name, boolean errorP);
boolean bind_to_surrogateP(Object* self, char* name, boolean clipoldvalueP, boolean askforpermissionP, Object*& _return1, Surrogate*& _return2);
Symbol* shadow_symbol(char* name);
Surrogate* shadow_surrogate(char* name);
boolean shadowed_symbolP(Generalized_Symbol* symbol);
cpp_function_code get_constructor(Class* renamed_Class, boolean warnP);
Object* create_object(Surrogate* type, int initial_value_pairs, ...);
Boolean_Wrapper* coerce_to_boolean(Object* object);
Class* define_stella_class(Surrogate* name, List* supers, List* slots, Keyword_Key_Value_List* options);
Slot* define_stella_slot(Symbol* name, Surrogate* owner, Surrogate* basetype, Cons* typespecifier, Keyword_Key_Value_List* options);
void incorporate_class_options(Class* renamed_Class, Keyword_Key_Value_List* options);
boolean inline_methodP(Slot* slot);
void transfer_external_slot_to_new_class(Slot* externalslot, Class* newclass);
void transfer_demons_from_oldclass(Class* oldclass, Class* newclass);
void undefine_old_class(Class* oldclass, Class* newclass);
void destroy_class_and_subclasses(Class* self);
void insert_primitive_super(Surrogate* newsuper, List* supers);
void collect_most_specific_primitive_supers(Class* renamed_Class, List* supers);
List* most_specific_primitive_supers(Class* renamed_Class);
List* class_native_supers(Class* renamed_Class);
void remember_unfinalized_class(Class* renamed_Class, boolean forceP);
void forget_unfinalized_class(Class* renamed_Class);
void finalize_classes();
void resolve_children_references();
void finalize_slots();
void cleanup_unfinalized_classes();
void finalize_classes_and_slots();
void activate_class(Class* renamed_Class);
void add_primary_type(Class* renamed_Class);
void finalize_one_class(Class* renamed_Class);
boolean finalize_class(Class* renamed_Class);
boolean help_finalize_class(Class* renamed_Class, Surrogate* finalizedparent);
void unfinalize_class_and_subclasses(Class* renamed_Class);
Slot* attach_slot_to_owner(Slot* newslot);
void compute_slot_direct_equivalent(Slot* self);
void check_conformance_of_slot_signature(Slot* self);
Surrogate* collection_to_active_collection(Surrogate* type);
void activate_slot(Storage_Slot* self);
boolean multi_valued_slot_with_duplicatesP(Slot* self);
void compute_slot_inverses(Slot* self);
void finalize_local_slot(Slot* self);
void finalize_class_slots(Class* renamed_Class);
void unfinalize_class_slots(Class* renamed_Class);
void help_unfinalize_class_slots(Class* renamed_Class);
void add_direct_supers_back_links(Class* renamed_Class);
void add_direct_subs_back_links(Class* renamed_Class);
void remove_direct_supers_back_links(Class* renamed_Class);
void collect_direct_super_classes(Class* renamed_Class, List* parents);
void inherit_superclasses(Class* renamed_Class);
void uninherit_superclasses(Class* renamed_Class);
Class* two_argument_least_common_superclass(Class* class1, Class* class2);
Standard_Object* two_argument_least_common_supertype(Standard_Object* type1, Standard_Object* type2);
void inherit_slots(Class* renamed_Class);
boolean local_slotP(Slot* slot, Class* renamed_Class);
void uninherit_slots(Class* renamed_Class);
void initialize_slot_and_method_cache(Class* renamed_Class);
void register_slot_name(Slot* slot);
void unregister_slot_name(Slot* slot);
boolean registered_slot_nameP(Symbol* slot_name);
boolean warn_about_slot_shadowed_by_a_functionP(Slot* slot);
boolean warn_about_function_shadowing_slotsP(Method_Slot* function);
Slot* lookup_slot(Class* renamed_Class, Symbol* slot_name);
Slot* safe_lookup_slot(Class* renamed_Class, Symbol* slot_name);
Slot* lookup_visible_slot(Class* renamed_Class, Object* slot_name);
Slot* lookup_local_slot(Class* renamed_Class, Symbol* slot_name);
void clear_slot_and_method_cache(Class* renamed_Class);
void resize_slot_caches(int size);
Slot* get_slot(Standard_Object* self, Symbol* slot_name);
boolean conforming_type_specP(Standard_Object* sub_type_spec, Standard_Object* super_type_spec);
boolean identical_signaturesP(Method_Slot* method1, Method_Slot* method2);
void compute_required_slot_names(Class* renamed_Class);
void free_required_slot_names(Class* renamed_Class);
All_Class_Slots_Iterator* new_all_class_slots_iterator();
Object* access_all_class_slots_iterator_slot_value(All_Class_Slots_Iterator* self, Symbol* slotname, Object* value, boolean setvalueP);
void repair_slots();
void disconnect_classes();
boolean filter_unbound_surrogateP(Surrogate* self, All_Purpose_Iterator* iterator);
Iterator* unbound_surrogates(Module* module, boolean localP);
char* name_to_string(Object* name);
void print_unbound_surrogates(Cons* args);
void print_unbound_surrogates_evaluator_wrapper(Cons* arguments);
Generalized_Symbol* coerce_to_symbol(Object* name);
void print_undefined_super_classes(Object* renamed_Class);
List* collect_bad_super_classes(Surrogate* type, List* badones);
boolean root_classP(Class* renamed_Class);
void create_class_taxonomy();
boolean subclass_ofP(Class* subclass, Class* superclass);
boolean fast_subclass_ofP(Class* subclass, Class* superclass);
boolean subtype_ofP(Surrogate* sub_type, Surrogate* super_type);
boolean isaP(Object* object, Surrogate* type);
boolean taxonomy_subclass_ofP(Class* subclass, Class* superclass);
boolean taxonomy_isaP(Object* object, Surrogate* type);
Surrogate* intern_slotref(char* classname, char* slotname);
Surrogate* lookup_slotref(Surrogate* self, Symbol* slotname);
boolean slotrefP(Surrogate* self);
Slot* lookup_slot_from_slotref(Surrogate* slotref);
Surrogate* slotref_type(Surrogate* slotref);
void help_startup_classes1();
void help_startup_classes2();
void help_startup_classes3();
void help_startup_classes4();
void startup_classes();

// Auxiliary global declarations:
extern Surrogate* SGT_CLASSES_STELLA_CLASS;
extern Surrogate* SGT_CLASSES_STELLA_OBJECT;
extern Keyword* KWD_CLASSES_PUBLICp;
extern Symbol* SYM_CLASSES_STELLA_TRUE;
extern Symbol* SYM_CLASSES_STELLA_FALSE;
extern Surrogate* SGT_CLASSES_STELLA_UNKNOWN;
extern Keyword* KWD_CLASSES_PARAMETERS;
extern Symbol* SYM_CLASSES_STELLA_SLOT_TYPE_SPECIFIER;
extern Keyword* KWD_CLASSES_REQUIREDp;
extern Keyword* KWD_CLASSES_COMPONENTp;
extern Keyword* KWD_CLASSES_READ_ONLYp;
extern Keyword* KWD_CLASSES_ACTIVEp;
extern Symbol* SYM_CLASSES_STELLA_STORED_ACTIVEp;
extern Keyword* KWD_CLASSES_CONTEXT_SENSITIVEp;
extern Keyword* KWD_CLASSES_HARDWIREDp;
extern Keyword* KWD_CLASSES_ABSTRACTp;
extern Keyword* KWD_CLASSES_ALLOCATION;
extern Keyword* KWD_CLASSES_CLASS;
extern Symbol* SYM_CLASSES_STELLA_SLOT_ALLOCATION;
extern Keyword* KWD_CLASSES_INITIALLY;
extern Symbol* SYM_CLASSES_STELLA_SLOT_INITIAL_VALUE;
extern Keyword* KWD_CLASSES_DEFAULT;
extern Symbol* SYM_CLASSES_STELLA_SLOT_DEFAULT_EXPRESSION;
extern Keyword* KWD_CLASSES_READER;
extern Symbol* SYM_CLASSES_STELLA_SLOT_READER;
extern Keyword* KWD_CLASSES_WRITER;
extern Symbol* SYM_CLASSES_STELLA_SLOT_WRITER;
extern Keyword* KWD_CLASSES_INVERSE;
extern Symbol* SYM_CLASSES_STELLA_SLOT_INVERSE;
extern Keyword* KWD_CLASSES_RENAMES;
extern Symbol* SYM_CLASSES_STELLA_SLOT_RENAMES;
extern Keyword* KWD_CLASSES_DOCUMENTATION;
extern Symbol* SYM_CLASSES_STELLA_DOCUMENTATION;
extern Keyword* KWD_CLASSES_PROPERTIES;
extern Symbol* SYM_CLASSES_STELLA_PROPERTIES;
extern Keyword* KWD_CLASSES_META_ATTRIBUTES;
extern Symbol* SYM_CLASSES_STELLA_META_ATTRIBUTES;
extern Keyword* KWD_CLASSES_OPTION_KEYWORD;
extern Symbol* SYM_CLASSES_STELLA_SLOT_OPTION_KEYWORD;
extern Keyword* KWD_CLASSES_OPTION_HANDLER;
extern Symbol* SYM_CLASSES_STELLA_SLOT_OPTION_HANDLER;
extern Surrogate* SGT_CLASSES_STELLA_BOOLEAN;
extern Keyword* KWD_CLASSES_BIT;
extern Keyword* KWD_CLASSES_CL_NATIVE_TYPE;
extern Symbol* SYM_CLASSES_STELLA_CLASS_CL_NATIVE_TYPE;
extern Keyword* KWD_CLASSES_CPP_NATIVE_TYPE;
extern Symbol* SYM_CLASSES_STELLA_CLASS_CPP_NATIVE_TYPE;
extern Keyword* KWD_CLASSES_IDL_NATIVE_TYPE;
extern Symbol* SYM_CLASSES_STELLA_CLASS_IDL_NATIVE_TYPE;
extern Keyword* KWD_CLASSES_JAVA_NATIVE_TYPE;
extern Symbol* SYM_CLASSES_STELLA_CLASS_JAVA_NATIVE_TYPE;
extern Keyword* KWD_CLASSES_CL_STRUCTp;
extern Keyword* KWD_CLASSES_MIXINp;
extern Keyword* KWD_CLASSES_RECYCLE_METHOD;
extern Symbol* SYM_CLASSES_STELLA_CLASS_RECYCLE_METHOD;
extern Keyword* KWD_CLASSES_EXTENSION;
extern Symbol* SYM_CLASSES_STELLA_CLASS_EXTENSION_NAME;
extern Keyword* KWD_CLASSES_CREATOR;
extern Symbol* SYM_CLASSES_STELLA_CLASS_CREATOR;
extern Keyword* KWD_CLASSES_INITIALIZER;
extern Symbol* SYM_CLASSES_STELLA_CLASS_INITIALIZER;
extern Keyword* KWD_CLASSES_TERMINATOR;
extern Symbol* SYM_CLASSES_STELLA_CLASS_TERMINATOR;
extern Keyword* KWD_CLASSES_DESTRUCTOR;
extern Symbol* SYM_CLASSES_STELLA_CLASS_DESTRUCTOR;
extern Keyword* KWD_CLASSES_INITIAL_VALUE;
extern Symbol* SYM_CLASSES_STELLA_CLASS_INITIAL_VALUE;
extern Keyword* KWD_CLASSES_PRINT_FORM;
extern Symbol* SYM_CLASSES_STELLA_PRINT_FORM;
extern Keyword* KWD_CLASSES_EQUALITY_TEST;
extern Keyword* KWD_CLASSES_KEY;
extern Symbol* SYM_CLASSES_STELLA_CLASS_KEY;
extern Symbol* SYM_CLASSES_STELLA_CLASS_PARAMETERS;
extern Keyword* KWD_CLASSES_SYNONYMS;
extern Symbol* SYM_CLASSES_STELLA_CLASS_SYNONYMS;
extern Keyword* KWD_CLASSES_CHILDREN;
extern Surrogate* SGT_CLASSES_STELLA_METHOD_SLOT;
extern Symbol* SYM_CLASSES_STELLA_SLOT_GUARD_DEMONS;
extern Symbol* SYM_CLASSES_STELLA_SLOT_DEMONS;
extern Symbol* SYM_CLASSES_STELLA_CLASS_CONSTRUCTOR_DEMONS;
extern Symbol* SYM_CLASSES_STELLA_CLASS_GUARD_CONSTRUCTOR_DEMONS;
extern Symbol* SYM_CLASSES_STELLA_CLASS_DESTRUCTOR_DEMONS;
extern Symbol* SYM_CLASSES_STELLA_CLASS_GUARD_DESTRUCTOR_DEMONS;
extern Surrogate* SGT_CLASSES_STELLA_ACTIVE_OBJECT;
extern Surrogate* SGT_CLASSES_STELLA_STANDARD_OBJECT;
extern Symbol* SYM_CLASSES_STELLA_PRIMARY_TYPE;
extern Symbol* SYM_CLASSES_STELLA_SELF;
extern Keyword* KWD_CLASSES_TYPE;
extern Symbol* SYM_CLASSES_STELLA_TYPE;
extern Keyword* KWD_CLASSES_AUXILIARYp;
extern Symbol* SYM_CLASSES_STELLA_RETURN;
extern Symbol* SYM_CLASSES_STELLA_CLASS_EXTENSION;
extern Symbol* SYM_CLASSES_STELLA_BADp;
extern Surrogate* SGT_CLASSES_STELLA_SET;
extern Surrogate* SGT_CLASSES_STELLA_ACTIVE_SET;
extern Surrogate* SGT_CLASSES_STELLA_LIST;
extern Surrogate* SGT_CLASSES_STELLA_ACTIVE_LIST;
extern Surrogate* SGT_CLASSES_STELLA_COLLECTION;
extern Surrogate* SGT_CLASSES_STELLA_SET_MIXIN;
extern Symbol* SYM_CLASSES_STELLA_INVERSE;
extern Keyword* KWD_CLASSES_DYNAMIC;
extern Surrogate* SGT_CLASSES_STELLA_DYNAMIC_SLOTS_MIXIN;
extern Keyword* KWD_CLASSES_INSTANCE;
extern Surrogate* SGT_CLASSES_STELLA_CONTEXT_SENSITIVE_OBJECT;
extern Surrogate* SGT_CLASSES_STELLA_CONTEXT_SENSITIVE_MIXIN;
extern Surrogate* SGT_CLASSES_STELLA_VOID;
extern Surrogate* SGT_CLASSES_STELLA_TABLE;
extern Symbol* SYM_CLASSES_STELLA_CLASS_REQUIRED_SLOT_NAMES;
extern Surrogate* SGT_CLASSES_STELLA_ALL_CLASS_SLOTS_ITERATOR;
extern Symbol* SYM_CLASSES_STELLA_ITERATOR_CONS_LIST;
extern Symbol* SYM_CLASSES_STELLA_ITERATOR_OBJECT;
extern Surrogate* SGT_CLASSES_STELLA_GENERALIZED_SYMBOL;
extern Symbol* SYM_CLASSES_STELLA_ANY;
extern Surrogate* SGT_CLASSES_STELLA_ANY;
extern Surrogate* SGT_CLASSES_STELLA_SLOT;
extern Symbol* SYM_CLASSES_STELLA_STARTUP_CLASSES;
extern Symbol* SYM_CLASSES_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
