// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/cpp-translate.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/



namespace stella {

// Global declarations:
extern DECLARE_STELLA_SPECIAL(oDUMMYDECLARATIONSo, Cons* );
extern DECLARE_STELLA_SPECIAL(oCURRENTDUMMYINDEXo, int );
extern Key_Value_List* oOPERATOR_TABLEo;
extern String_Hash_Table* oCPP_RESERVED_WORD_TABLEo;
extern DECLARE_STELLA_SPECIAL(oCPP_CURRENT_UNIT_MODULEo, Module* );
extern char* oCPP_CHARACTER_SUBSTITUTION_TABLEo;
extern DECLARE_STELLA_SPECIAL(oCPP_NAME_QUALIFICATION_MODEo, Keyword* );
extern char* oCPP_NAMESPACE_SEPARATORo;

// Function signatures:
boolean cpp_use_garbage_collectorP();
Cons* cpp_lookup_operator_table(Symbol* renamed_Operator);
String_Wrapper* cpp_yield_renamed_reserved_word(Symbol* word);
String_Hash_Table* cpp_create_reserved_word_table();
String_Wrapper* cpp_lookup_reserved_word_table(Symbol* word);
Cons* cpp_translate_unit(Translation_Unit* unit);
Cons* cpp_translate_list_of_trees(Cons* trees);
Object* cpp_translate_a_tree(Object* tree);
Cons* cpp_translate_verbatim_tree(Cons* tree);
Cons* cpp_translate_special_tree(Cons* tree);
Cons* cpp_translate_inline_tree(Cons* tree);
Cons* tokenize_verbatim_method_body(Cons* tree);
Object* cpp_translate_inline_call_tree(Cons* tree);
Cons* cpp_translate_print_native_stream(Cons* tree);
Cons* cpp_translate_defprint_unit(Translation_Unit* unit);
Cons* cpp_translate_signal(Cons* tree);
Cons* cpp_translate_handler_case(Cons* tree);
Cons* cpp_translate_handle_exception(Cons* tree);
Cons* cpp_translate_unwind_protect(Cons* tree);
Cons* cpp_translate_cast(Cons* tree);
Cons* cpp_translate_mv_setq(Cons* tree);
Cons* cpp_translate_mv_function_call(Cons* functioncall, Cons* variables);
Cons* cpp_translate_define_global_variable_unit(Translation_Unit* unit);
boolean symbol_caseP(Object* keyform);
Cons* cpp_yield_symbol_id_form(int symbolid);
Cons* cpp_translate_condition(Cons* condition, boolean symbolcasep);
Cons* cpp_translate_case_tree(Cons* tree);
Cons* cpp_translate_cond_tree(Cons* tree);
Cons* cpp_translate_loop(Cons* tree);
Cons* cpp_translate_while(Cons* tree);
Cons* cpp_translate_progn(Cons* tree);
Cons* cpp_translate_with_process_lock(Cons* tree);
Cons* cpp_translate_break(Cons* tree);
Cons* cpp_translate_continue(Cons* tree);
Cons* cpp_translate_if_tree(Cons* tree);
Cons* cpp_translate_choose_tree(Cons* tree);
Cons* cpp_translate_when_tree(Cons* tree);
Cons* cpp_translate_unless_tree(Cons* tree);
Cons* cpp_translate_foreach_tree(Cons* tree);
Cons* cpp_yield_va_start_tree(Symbol* iteratorvar);
Cons* cpp_yield_va_end_tree(Symbol* iteratorvar);
Symbol* cpp_yield_va_iterator_helper_variable(Symbol* iteratorvar);
Cons* cpp_yield_va_iterator_declarations(Symbol* iteratorvar);
Cons* cpp_translate_argument_list_tree(Symbol* renamed_Operator, Surrogate* owner, Object* argument);
Cons* cpp_translate_the_code(Cons* tree);
Cons* cpp_translate_sys_pointer_to_function(Cons* tree);
Cons* cpp_translate_sys_new(Cons* tree);
Cons* cpp_translate_new_array(Cons* tree);
Cons* cpp_translate_void_sys(Cons* tree);
Cons* cpp_translate_typed_sys(Cons* tree);
Object* cpp_translate_bad_sys(Cons* tree);
Cons* cpp_translate_sys_referenced_slot_value(Cons* tree);
Cons* cpp_translate_sys_slot_value(Cons* tree);
Cons* cpp_translate_sys_slot_value_setter(Cons* tree);
Cons* cpp_translate_make_tree(Cons* tree);
Cons* cpp_translate_startup_time_progn(Cons* tree);
boolean cpp_stream_is_standard_outputP(Object* tree);
Cons* cpp_translate_print_stream(Cons* tree);
Cons* cpp_translate_setq_tree(Cons* tree);
Cons* cpp_translate_null();
Cons* cpp_translate_let_tree(Cons* tree);
String_Wrapper* cpp_translate_type_spec(Standard_Object* typespec);
String_Wrapper* cpp_translate_and_pointerize_type_spec(Standard_Object* typespec);
String_Wrapper* cpp_translate_and_referencize_type_spec(Standard_Object* typespec);
String_Wrapper* cpp_translate_array_type(Parametric_Type_Specifier* arraytype);
boolean cpp_translated_array_typeP(Object* translatedtype);
char* cpp_generate_array_typed_entity(char* entity, char* translatedarraytype);
char* cpp_create_character_substitution_table();
char* replace_first_character_with_string(char* string, char* newprefix);
char* cpp_substitute_forbidden_characters(char* name, Keyword* caseconvention);
char* cpp_change_case(Generalized_Symbol* symbol, Keyword* caseconvention);
char* help_cpp_change_case(Generalized_Symbol* symbol, Keyword* caseconvention);
char* cpp_yield_namespace_prefix_from_module(Module* module);
char* cpp_yield_namespace_prefix(Generalized_Symbol* symbol);
Keyword* cpp_name_qualification_mode();
boolean cpp_qualify_nameP(Generalized_Symbol* namesymbol);
char* cpp_yield_qualified_name(char* translatedname, Generalized_Symbol* sourcesymbol);
String_Wrapper* cpp_translate_name(Symbol* namesymbol);
String_Wrapper* cpp_translate_global_name(Symbol* namesymbol);
String_Wrapper* cpp_translate_class_parameter_name(Symbol* namesymbol);
String_Wrapper* cpp_translate_return_parameter_name(Symbol* namesymbol, int parameternumber);
String_Wrapper* cpp_translate_symbol_constant_name(Generalized_Symbol* symbol);
String_Wrapper* cpp_translate_symbol_constant_id(Generalized_Symbol* symbol);
String_Wrapper* cpp_translate_symbol_name(Symbol* symbol);
String_Wrapper* cpp_translate_symbol_id(Symbol* symbol);
String_Wrapper* cpp_translate_surrogate_name(Surrogate* surrogate);
String_Wrapper* cpp_translate_surrogate_id(Surrogate* surrogate);
String_Wrapper* cpp_translate_keyword_name(Keyword* keyword);
String_Wrapper* cpp_translate_keyword_id(Keyword* keyword);
String_Wrapper* cpp_translate_class_typename(Generalized_Symbol* namesymbol);
String_Wrapper* cpp_translate_class_name(Generalized_Symbol* namesymbol);
boolean cpp_reference_typeP(Standard_Object* typespec);
String_Wrapper* cpp_referencize_type(Standard_Object* typespec);
Object* cpp_translate_function_parameter(Symbol* name, Standard_Object* type, Method_Slot* method);
Cons* cpp_translate_return_parameter(int parameternumber, Standard_Object* parametertype);
Cons* cpp_translate_function_parameters(Method_Slot* method);
boolean slot_reader_from_nameP(Symbol* methodname, Standard_Object* methodowner);
boolean slot_readerP(Method_Slot* method);
String_Wrapper* cpp_translate_constructor_name(Method_Slot* constructor);
String_Wrapper* cpp_translate_function_name_from_name(Symbol* functionname);
String_Wrapper* cpp_translate_function_name(Method_Slot* function);
String_Wrapper* cpp_translate_method_name_from_name(Symbol* methodname, Standard_Object* methodowner);
String_Wrapper* cpp_translate_method_name(Method_Slot* method);
Cons* delete_quoted_null_statements(Cons* trees);
boolean cpp_method_object_is_functionP(Method_Slot* method);
boolean cpp_method_object_is_overloaded_functionP(Method_Slot* method);
Cons* wrap_method_body_with_cpp_auxiliary_declarations(Cons* methodbody, Cons* declarations);
Cons* cpp_translate_define_method_unit(Translation_Unit* unit);
Cons* cpp_translate_return_tree(Cons* tree);
Cons* cpp_translate_actual_parameters(Cons* tree);
Cons* cpp_translate_variable_length_actuals(Cons* actuals, Method_Slot* method);
Cons* cpp_translate_call_method_setter(Cons* tree);
Symbol* cpp_create_overloaded_function_name(Symbol* functionname, Surrogate* classtype);
Cons* cpp_translate_method_call(Cons* tree, boolean referencedP);
Cons* cpp_translate_normal_method_call(Symbol* methodname, Surrogate* owner, Cons* arguments, boolean referencedP);
Cons* cpp_translate_definedP_method_call(Surrogate* argumenttype, Object* argument, boolean nullP);
Cons* cpp_translate_nth_method_call(Symbol* renamed_Operator, Surrogate* owner, Cons* arguments);
Cons* cpp_translate_aref_method_call(Symbol* renamed_Operator, Surrogate* owner, Cons* arguments);
Cons* cpp_translate_code_signature(Cons* signature);
Cons* cpp_translate_method_code_signature(Cons* signature);
Cons* cpp_translate_call_function_code(Cons* tree);
Cons* cpp_translate_call_method_code(Cons* tree);
Cons* get_last_n_elements(Cons* list, int n);
Cons* cpp_translate_function_call(Cons* tree, Method_Slot* method);
Cons* cpp_translate_operator_tree(Cons* tree);
Cons* cpp_translate_operator_call(Cons* operatornames, Cons* arguments, int arity);
Cons* cpp_translate_hardcoded_symbol_reference(Symbol* renamed_Operator, int offset);
void help_startup_cpp_translate1();
void help_startup_cpp_translate2();
void help_startup_cpp_translate3();
void help_startup_cpp_translate4();
void help_startup_cpp_translate5();
void help_startup_cpp_translate6();
void startup_cpp_translate();

// Auxiliary global declarations:
extern Keyword* KWD_CPP_TRANSLATE_USE_CPP_GARBAGE_COLLECTOR;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_KEY_VALUE_LIST;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_ii;
extern Symbol* SYM_CPP_TRANSLATE_STELLA___;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_i;
extern Symbol* SYM_CPP_TRANSLATE_STELLA__;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_o;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_s;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_EQp;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_xe;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_g;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_ge;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_eg;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_l;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_el;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_le;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_AND;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_OR;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_NOT;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CHOOSE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_ASM;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_AUTO;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_BREAK;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CASE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CATCH;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CHAR;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CLASS;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CONST;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CONTINUE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_DEFAULT;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_DELETE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_DO;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_DOUBLE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_ELSE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_ENUM;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_EXTERN;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_FLOAT;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_FOR;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_FRIEND;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_GOTO;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_IF;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_INLINE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_INT;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_LONG;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_NEW;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_OPERATOR;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_PRIVATE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_PROTECTED;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_PUBLIC;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_REGISTER;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_RETURN;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SHORT;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SIGNED;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SIZEOF;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_STATIC;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_STRUCT;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SWITCH;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_TEMPLATE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_THROW;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_TRY;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_TYPEDEF;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_UNION;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_UNSIGNED;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_VIRTUAL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_VOID;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_VOLATILE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_WHILE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_TYPENAME;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_GLOBAL_VARIABLE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_TYPE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_METHOD;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_MACRO;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_PRINT_METHOD;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_STARTUP_TIME_PROGN;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_VERBATIM;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_CONS;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SPECIAL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_UNWIND_PROTECT;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_SIGNAL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_HANDLER_CASE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_HANDLE_EXCEPTION;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_VOID_SYS;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_BAD_SYS;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_TYPED_SYS;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SETQ;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_SLOT_VALUE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_REFERENCED_SLOT_VALUE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_SLOT_VALUE_SETTER;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_CALL_METHOD;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_REFERENCED_CALL_METHOD;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_CALL_FUNCTION;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_PROGN;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_WITH_PROCESS_LOCK;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_LOOP;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_FOREACH;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_LET;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CAST;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SAFE_CAST;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_WHEN;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_UNLESS;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_COND;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_MAKE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_NEW;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_MV_SETQ;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_CALL_FUNCTION_CODE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_CALL_METHOD_CODE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_INLINE_CALL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_THE_CODE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_POINTER_TO_FUNCTION;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_IGNORE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_PRINT_STREAM;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_PRINT_NATIVE_STREAM;
extern Keyword* KWD_CPP_TRANSLATE_CPP;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_VERBATIM;
extern Keyword* KWD_CPP_TRANSLATE_UNBIND_WITH_DESTRUCTORS;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_CALL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_IDENT;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_ACTUALS;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_BLOCK;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_COMMENT;
extern Keyword* KWD_CPP_TRANSLATE_DIGIT;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_PRINT_NATIVE_STREAM;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_DEFPRINT;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_RETURN;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_STREAM;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_SIGNAL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_DEREFERENCE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_HANDLER_CASE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_CATCH;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_TYPE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_LOCAL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_UNWIND_PROTECT;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_FLOAT;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_INTEGER_WRAPPER;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_INTEGER;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_FLOAT_WRAPPER;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_CAST;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_ASSIGN;
extern Keyword* KWD_CPP_TRANSLATE_UNBOUND_SPECIAL_VARIABLE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_SPECIAL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_GLOBAL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SYMBOL_ID;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_OTHERWISE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_CASE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_PROGN;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_COND;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_LOOP;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_WHILE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_WITH_PROCESS_LOCK;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_BREAK;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_CONTINUE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_IF;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_WHEN;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_UNLESS;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_ARGUMENT_LIST_ITERATOR;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_FOREACH;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_VA_START;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_VA_END;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_ALLOCATE_ITERATOR;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_LENGTH;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_NEXTp;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_ARGUMENT;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_BINARY_OP;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_UNARY_OP;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_LITERAL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_VA_ARG;
extern Keyword* KWD_CPP_TRANSLATE_FUNCTION;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_POINTER;
extern Keyword* KWD_CPP_TRANSLATE_METHOD;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_POINTER;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_TRUE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_ANY_VALUE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_ARRAY_REFERENCE;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_VOID;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_REFERENCED_SLOT_VALUE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_SLOT_VALUE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_SLOT_VALUE_SETTER;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CLASS_CPP_NATIVE_TYPE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_MAKE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_STARTUP_TIME_PROGN;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_PRINT_STREAM;
extern Keyword* KWD_CPP_TRANSLATE_WARN;
extern Keyword* KWD_CPP_TRANSLATE_ERROR;
extern Keyword* KWD_CPP_TRANSLATE_CONTINUABLE_ERROR;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_STANDARD_ERROR;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_STANDARD_OUT;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_ENDL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_EOL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_REFERENCED_METHOD_CALL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_NULL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_SET;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_SYMBOL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_GET;
extern Keyword* KWD_CPP_TRANSLATE_CPP_STANDALONE;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_UNKNOWN;
extern Keyword* KWD_CPP_TRANSLATE_UPPERCASE;
extern Keyword* KWD_CPP_TRANSLATE_LOWERCASE;
extern Keyword* KWD_CPP_TRANSLATE_CAPITALIZED;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_CPP_CHANGE_CASE_MEMO_TABLE_000;
extern Keyword* KWD_CPP_TRANSLATE_UNESCAPED;
extern Keyword* KWD_CPP_TRANSLATE_NO;
extern Keyword* KWD_CPP_TRANSLATE_PRESERVE;
extern Keyword* KWD_CPP_TRANSLATE_UPCASE;
extern Keyword* KWD_CPP_TRANSLATE_DOWNCASE;
extern Keyword* KWD_CPP_TRANSLATE_TITLECASE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_MODULE_CPP_PACKAGE;
extern Keyword* KWD_CPP_TRANSLATE_CLEVER;
extern Keyword* KWD_CPP_TRANSLATE_FULL;
extern Keyword* KWD_CPP_TRANSLATE_NEVER;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_METHOD_VARIABLE_ARGUMENTSp;
extern Symbol* SYM_CPP_TRANSLATE_STELLA__RETURN;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_VAR_ARGS;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_STORAGE_SLOT;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_METHOD_NATIVEp;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_LITERAL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_THIS;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_DOCUMENTATION;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_METHOD;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_SETTER_CALL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_DEFINEDp;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_NULLp;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_NTH;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_NTH_SETTER;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_AREF;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_AREF_SETTER;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_ARGUMENT_LIST;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_CALL;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_OBJECT;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_BOOLEAN;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_STRING;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_MUTABLE_STRING;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_NATIVE_VECTOR;
extern Surrogate* SGT_CPP_TRANSLATE_STELLA_ARRAY;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_SIGNATURE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_SIGNATURE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_FUNCALL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_CODE_CALL;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_GET_SYM;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_GET_KWD;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_GET_SGT;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_DUMMY;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_TERNARY_OP;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_STARTUP_CPP_TRANSLATE;
extern Symbol* SYM_CPP_TRANSLATE_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
