// idl-translate-file.cc

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/

#include "stella/stella-system.hh"

namespace stella {

void idl_translate_class_to_stream(Class* renamed_Class, ostream* native_stream) {
  { Translation_Unit* self_000 = new_translation_unit();

    self_000->the_object = renamed_Class;
    { Translation_Unit* tempunit = self_000;

      { 
        BIND_STELLA_SPECIAL(oCURRENT_STREAMo, Output_Stream*, NULL);
        { Output_Stream* self_001 = new_output_stream();

          self_001->native_stream = native_stream;
          oCURRENT_STREAMo.set(self_001);
        }
        idl_output_statement(idl_translate_define_native_class_unit(tempunit));
      }
    }
  }
}

char* oIDL_TRANSLATED_FILE_SUFFIXo = "";

char* idl_make_code_output_file_name(char* sourcefile) {
  return (string_concatenate(file_name_without_extension(sourcefile), string_concatenate(oIDL_TRANSLATED_FILE_SUFFIXo, ".sidl", 0), 0));
}

void idl_output_all_units_to_file(char* sourcefile) {
  { char* codeoutputfile = idl_make_code_output_file_name(sourcefile);
    Output_File_Stream* codeoutputstream = new_output_file_stream(codeoutputfile);
    Cons* globals = NIL;
    Cons* methods = NIL;
    Cons* verbatimstatements = NIL;
    Cons* forms = NIL;

    { 
      BIND_STELLA_SPECIAL(oCURRENT_STREAMo, Output_Stream*, codeoutputstream);
      oTRANSLATIONUNITSo.set(oTRANSLATIONUNITSo.get()->reverse());
      { Translation_Unit* unit = NULL;
        Cons* iter_000 = oTRANSLATIONUNITSo.get()->the_cons_list;

        while (!(iter_000 == NIL)) {
          unit = ((Translation_Unit*)(iter_000->value));
          iter_000 = iter_000->rest;
          { Symbol* test_value_000 = unit->category;

            if ((test_value_000 == SYM_IDL_TRANSLATE_FILE_STELLA_METHOD) ||
                ((test_value_000 == SYM_IDL_TRANSLATE_FILE_STELLA_PRINT_METHOD) ||
                 (test_value_000 == SYM_IDL_TRANSLATE_FILE_STELLA_MACRO))) {
              methods = cons(unit->translation, methods);
            }
            else if (test_value_000 == SYM_IDL_TRANSLATE_FILE_STELLA_VERBATIM) {
              verbatimstatements = cons(unit->translation, verbatimstatements);
            }
            else if (test_value_000 == SYM_IDL_TRANSLATE_FILE_STELLA_GLOBAL_VARIABLE) {
              globals = cons(unit->translation, globals);
            }
            else {
              forms = cons(unit->translation, forms);
            }
          }
        }
      }
      cout << "Writing " << "`" << codeoutputfile << "'" << "..." << endl;
      *(oCURRENT_STREAMo.get()->native_stream) << "// " << codeoutputfile << endl << endl;
      if (translate_with_copyright_headerP()) {
        output_copyright_header(oCURRENT_STREAMo.get());
      }
      { Object* form = NULL;
        Cons* iter_001 = forms;

        while (!(iter_001 == NIL)) {
          form = iter_001->value;
          iter_001 = iter_001->rest;
          idl_output_statement(((Cons*)(form)));
        }
      }
      codeoutputstream->free();
    }
  }
}

void idl_translate_file(char* filename) {
  translate_file(filename, KWD_IDL_TRANSLATE_FILE_IDL, FALSE);
}

void startup_idl_translate_file() {
  { 
    BIND_STELLA_SPECIAL(oMODULEo, Module*, oSTELLA_MODULEo);
    BIND_STELLA_SPECIAL(oCONTEXTo, Context*, oMODULEo.get());
    if (current_startup_time_phaseP(2)) {
      SYM_IDL_TRANSLATE_FILE_STELLA_METHOD = ((Symbol*)(intern_rigid_symbol_wrt_module("METHOD", NULL, 0)));
      SYM_IDL_TRANSLATE_FILE_STELLA_PRINT_METHOD = ((Symbol*)(intern_rigid_symbol_wrt_module("PRINT-METHOD", NULL, 0)));
      SYM_IDL_TRANSLATE_FILE_STELLA_MACRO = ((Symbol*)(intern_rigid_symbol_wrt_module("MACRO", NULL, 0)));
      SYM_IDL_TRANSLATE_FILE_STELLA_VERBATIM = ((Symbol*)(intern_rigid_symbol_wrt_module("VERBATIM", NULL, 0)));
      SYM_IDL_TRANSLATE_FILE_STELLA_GLOBAL_VARIABLE = ((Symbol*)(intern_rigid_symbol_wrt_module("GLOBAL-VARIABLE", NULL, 0)));
      KWD_IDL_TRANSLATE_FILE_IDL = ((Keyword*)(intern_rigid_symbol_wrt_module("IDL", NULL, 2)));
      SYM_IDL_TRANSLATE_FILE_STELLA_STARTUP_IDL_TRANSLATE_FILE = ((Symbol*)(intern_rigid_symbol_wrt_module("STARTUP-IDL-TRANSLATE-FILE", NULL, 0)));
      SYM_IDL_TRANSLATE_FILE_STELLA_METHOD_STARTUP_CLASSNAME = ((Symbol*)(intern_rigid_symbol_wrt_module("METHOD-STARTUP-CLASSNAME", NULL, 0)));
    }
    if (current_startup_time_phaseP(6)) {
      finalize_classes();
    }
    if (current_startup_time_phaseP(7)) {
      define_function_object("IDL-TRANSLATE-CLASS-TO-STREAM", "(DEFUN IDL-TRANSLATE-CLASS-TO-STREAM ((CLASS CLASS) (NATIVE-STREAM NATIVE-OUTPUT-STREAM)))", ((cpp_function_code)(&idl_translate_class_to_stream)), NULL);
      define_function_object("IDL-MAKE-CODE-OUTPUT-FILE-NAME", "(DEFUN (IDL-MAKE-CODE-OUTPUT-FILE-NAME FILE-NAME) ((SOURCEFILE FILE-NAME)))", ((cpp_function_code)(&idl_make_code_output_file_name)), NULL);
      define_function_object("IDL-OUTPUT-ALL-UNITS-TO-FILE", "(DEFUN IDL-OUTPUT-ALL-UNITS-TO-FILE ((SOURCEFILE FILE-NAME)))", ((cpp_function_code)(&idl_output_all_units_to_file)), NULL);
      define_function_object("IDL-TRANSLATE-FILE", "(DEFUN IDL-TRANSLATE-FILE ((FILENAME FILE-NAME)))", ((cpp_function_code)(&idl_translate_file)), NULL);
      define_function_object("STARTUP-IDL-TRANSLATE-FILE", "(DEFUN STARTUP-IDL-TRANSLATE-FILE () :PUBLIC? TRUE)", ((cpp_function_code)(&startup_idl_translate_file)), NULL);
      { Method_Slot* function = lookup_function(SYM_IDL_TRANSLATE_FILE_STELLA_STARTUP_IDL_TRANSLATE_FILE);

        set_dynamic_slot_value(function->dynamic_slots, SYM_IDL_TRANSLATE_FILE_STELLA_METHOD_STARTUP_CLASSNAME, wrap_string("Startup-Idl-Translate-File"), NULL_STRING_WRAPPER);
      }
    }
    if (current_startup_time_phaseP(8)) {
      finalize_slots();
      cleanup_unfinalized_classes();
    }
    if (current_startup_time_phaseP(9)) {
      define_stella_global_variable_from_stringified_source("(DEFGLOBAL *IDL-TRANSLATED-FILE-SUFFIX* STRING \"\")");
    }
  }
}

Symbol* SYM_IDL_TRANSLATE_FILE_STELLA_METHOD = NULL;

Symbol* SYM_IDL_TRANSLATE_FILE_STELLA_PRINT_METHOD = NULL;

Symbol* SYM_IDL_TRANSLATE_FILE_STELLA_MACRO = NULL;

Symbol* SYM_IDL_TRANSLATE_FILE_STELLA_VERBATIM = NULL;

Symbol* SYM_IDL_TRANSLATE_FILE_STELLA_GLOBAL_VARIABLE = NULL;

Keyword* KWD_IDL_TRANSLATE_FILE_IDL = NULL;

Symbol* SYM_IDL_TRANSLATE_FILE_STELLA_STARTUP_IDL_TRANSLATE_FILE = NULL;

Symbol* SYM_IDL_TRANSLATE_FILE_STELLA_METHOD_STARTUP_CLASSNAME = NULL;

} // end of namespace stella
