// java-output.cc

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/

#include "stella/stella-system.hh"

namespace stella {

DEFINE_STELLA_SPECIAL(oJAVA_INDENT_CHARSo, int , 0);

Key_Value_List* oJAVA_STELLA_PACKAGE_MAPPINGo = NULL;

char* java_stella_package() {
  { char* stellapackage = oSTELLA_MODULEo->java_package_reader();

    if (stellapackage != NULL) {
      return (stellapackage);
    }
    else {
      return ("stella");
    }
  }
}

void java_output_parse_tree(Cons* constree) {
  { 
    BIND_STELLA_SPECIAL(oJAVA_INDENT_CHARSo, int, 0);
    oJAVA_STELLA_PACKAGE_MAPPINGo->insert_at(wrap_string("STELLAROOT"), wrap_string(java_stella_package()));
    java_output_statement(constree);
  }
}

void java_bump_indent() {
  oJAVA_INDENT_CHARSo.set(oJAVA_INDENT_CHARSo.get() + 2);
}

void java_unbump_indent() {
  oJAVA_INDENT_CHARSo.set(oJAVA_INDENT_CHARSo.get() - 2);
}

void java_indent() {
  { int d = NULL_INTEGER;
    int iter_000 = 1;
    int upper_bound_000 = oJAVA_INDENT_CHARSo.get();
    boolean unboundedP_000 = upper_bound_000 == NULL_INTEGER;

    while (unboundedP_000 ||
        (iter_000 <= upper_bound_000)) {
      d = iter_000;
      iter_000 = iter_000 + 1;
      *(oCURRENT_STREAMo.get()->native_stream) << " ";
    }
  }
}

void java_output_statement(Object* statement) {
  if (safe_primary_type(statement) == SGT_JAVA_OUTPUT_STELLA_CONS) {
    { Object* statement_000 = statement;
      Cons* statement = ((Cons*)(statement_000));

      if (statement == NIL) {
        return;
      }
      if (consP(statement->value) ||
          (!((boolean)(statement->value)))) {
        {
          java_output_statement(statement->value);
          java_output_statement(statement->rest);
        }
      }
      else {
        { Generalized_Symbol* test_value_000 = ((Generalized_Symbol*)(statement->value));

          if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_CLASS) {
            java_output_class(statement->rest, FALSE);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_EXCEPTION_CLASS) {
            java_output_class(statement->rest, TRUE);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_NAMED_STATEMENT) {
            java_output_named_statement(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_STATEMENTS) {
            java_output_statements(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_IDENT) {
            java_output_identifier(((String_Wrapper*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_EOL) {
            java_output_identifier(((String_Wrapper*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_LITERAL) {
            statement->rest->value->java_output_literal();
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_COMMENT) {
            java_output_comment(((String_Wrapper*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_SYMBOL) {
            statement->rest->value->java_output_literal();
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_CATCH) {
            java_output_catch(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_THROW) {
            java_output_throw(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_UNWIND_PROTECT) {
            java_output_unwind_protect(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_HANDLER_CASE) {
            java_output_handler_case(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_SIGNAL) {
            java_output_signal(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_VERBATIM) {
            java_output_verbatim(((String_Wrapper*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_CAST) {
            java_output_cast(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_GLOBAL) {
            java_output_global_definition(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_SPECIAL) {
            java_output_special_definition(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_TYPE) {
            java_output_type_expression(((Cons*)(statement->rest)));
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_PROGN) {
            java_output_progn(((Cons*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_BLOCK) {
            java_output_block(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_WITH_PROCESS_LOCK) {
            java_output_with_process_lock(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_RETURN) {
            java_output_return(((Cons*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_MAKE) {
            java_output_make(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCALL) {
            java_output_funcall(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_CODE_CALL) {
            java_output_method_code_call(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_ASSIGN) {
            java_output_assignment(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_BREAK) {
            java_output_break(((Cons*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_CONTINUE) {
            java_output_continue(((Cons*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_COND) {
            java_output_cond(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_CASE) {
            java_output_case(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_IF) {
            java_output_if(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_WHEN) {
            java_output_when(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_UNLESS) {
            java_output_unless(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_LOOP) {
            java_output_loop(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_WHILE) {
            java_output_while(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_FOREACH) {
            java_output_foreach(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_SLOT_VALUE) {
            java_output_slot_value(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_SLOT_VALUE_SETTER) {
            java_output_slot_value_setter(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_UNARY_OP) {
            java_output_unary_operator(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_BINARY_OP) {
            java_output_binary_operator(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_TERNARY_OP) {
            java_output_ternary_operator(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCTION_CALL) {
            java_output_function_call(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_CALL) {
            java_output_method_call(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_ACTUALS) {
            java_output_actual_parameters(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_MAKE_ARRAY) {
            java_output_make_array(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_ARRAY_INITIALIZER) {
            java_output_array(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_ANONYMOUS_ARRAY) {
            java_output_anonymous_array(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_AREF) {
            java_output_aref(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD) {
            java_output_method(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCTION) {
            java_output_method(statement->rest);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_PRINT_STREAM) {
            java_output_print_stream(statement->rest, FALSE);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_PRINT_NATIVE_STREAM) {
            java_output_print_stream(statement->rest, TRUE);
          }
          else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_DECLARATIONS) {
            java_output_declarations(((Cons*)(statement->rest)));
          }
          else {
            { Output_String_Stream* stream_000 = new_output_string_stream();

              *(stream_000->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
              throw *new_stella_exception(stream_000->the_string_reader());
            }
          }
        }
      }
    }
  }
  else {
    if (!((boolean)(statement))) {
      return;
    }
    statement->java_output_literal();
  }
}

void java_maybe_output_statement_with_parentheses(Object* statement) {
  if (java_operatorP(statement)) {
    *(oCURRENT_STREAMo.get()->native_stream) << "(";
  }
  java_output_statement(statement);
  if (java_operatorP(statement)) {
    *(oCURRENT_STREAMo.get()->native_stream) << ")";
  }
}

void java_output_identifier(String_Wrapper* identifier) {
  *(oCURRENT_STREAMo.get()->native_stream) << identifier->wrapper_value;
}

void Object::java_output_literal() {
  { Object* object = this;

  }
}

void string_java_output_literal(char* string) {
  *(oCURRENT_STREAMo.get()->native_stream) << "\"" << replace_substrings(replace_substrings(replace_substrings(replace_substrings(string, "\\\\", "\\"), "\\\"", make_string(1, '"')), "\\n", make_string(1, '\n')), "\\r", make_string(1, '\r')) << "\"";
}

void String_Wrapper::java_output_literal() {
  { String_Wrapper* string = this;

    string_java_output_literal(string->wrapper_value);
  }
}

void Mutable_String_Wrapper::java_output_literal() {
  { Mutable_String_Wrapper* string = this;

    *(oCURRENT_STREAMo.get()->native_stream) << "new StringBuffer(";
    string_java_output_literal((string->wrapper_value));
    *(oCURRENT_STREAMo.get()->native_stream) << ")";
  }
}

void Character_Wrapper::java_output_literal() {
  { Character_Wrapper* character = this;

    switch (character->wrapper_value) {
      case '\'': 
        *(oCURRENT_STREAMo.get()->native_stream) << "'\\''";
      break;
      case '\\': 
        *(oCURRENT_STREAMo.get()->native_stream) << "'\\\\'";
      break;
      case '\n': 
        *(oCURRENT_STREAMo.get()->native_stream) << "'\\n'";
      break;
      case '\b': 
        *(oCURRENT_STREAMo.get()->native_stream) << "'\\b'";
      break;
      case '\t': 
        *(oCURRENT_STREAMo.get()->native_stream) << "'\\t'";
      break;
      case '\r': 
        *(oCURRENT_STREAMo.get()->native_stream) << "'\\r'";
      break;
      case '\f': 
        *(oCURRENT_STREAMo.get()->native_stream) << "'\\f'";
      break;
      default:
        *(oCURRENT_STREAMo.get()->native_stream) << "'" << character->wrapper_value << "'";
      break;
    }
  }
}

void Integer_Wrapper::java_output_literal() {
  { Integer_Wrapper* renamed_Int = this;

    *(oCURRENT_STREAMo.get()->native_stream) << renamed_Int->wrapper_value;
  }
}

void Float_Wrapper::java_output_literal() {
  { Float_Wrapper* renamed_Float = this;

    *(oCURRENT_STREAMo.get()->native_stream) << renamed_Float->wrapper_value;
  }
}

void Boolean_Wrapper::java_output_literal() {
  { Boolean_Wrapper* boolean = this;

    if (boolean->wrapper_value) {
      *(oCURRENT_STREAMo.get()->native_stream) << "true";
    }
    else {
      *(oCURRENT_STREAMo.get()->native_stream) << "false";
    }
  }
}

void java_output_make_array(Cons* statement) {
  *(oCURRENT_STREAMo.get()->native_stream) << "new ";
  *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(statement->value))->wrapper_value;
  { Object* dimension = NULL;
    Cons* iter_000 = statement->rest;

    while (!(iter_000 == NIL)) {
      dimension = iter_000->value;
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << "[";
      java_output_statement(dimension);
      *(oCURRENT_STREAMo.get()->native_stream) << "]";
    }
  }
}

void java_output_array(Cons* arrayelements) {
  *(oCURRENT_STREAMo.get()->native_stream) << "{";
  if (((boolean)(arrayelements->value))) {
    java_output_statement(arrayelements->value);
  }
  { Object* element = NULL;
    Cons* iter_000 = arrayelements->rest;

    while (!(iter_000 == NIL)) {
      element = iter_000->value;
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << ", ";
      java_output_statement(element);
    }
  }
  *(oCURRENT_STREAMo.get()->native_stream) << "}";
}

void java_output_anonymous_array(Cons* statement) {
  *(oCURRENT_STREAMo.get()->native_stream) << "new ";
  *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(statement->value))->wrapper_value;
  *(oCURRENT_STREAMo.get()->native_stream) << " [] ";
  java_output_array(statement->rest);
}

void java_output_aref(Cons* statement) {
  java_output_statement(statement->value);
  { Object* dimension = NULL;
    Cons* iter_000 = statement->rest;

    while (!(iter_000 == NIL)) {
      dimension = iter_000->value;
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << "[";
      java_output_statement(dimension);
      *(oCURRENT_STREAMo.get()->native_stream) << "]";
    }
  }
}

void java_output_slot_value(Cons* statement) {
  java_output_statement(statement->value);
  *(oCURRENT_STREAMo.get()->native_stream) << "." << ((String_Wrapper*)(statement->rest->value))->wrapper_value;
}

void java_output_slot_value_setter(Cons* statement) {
  java_output_statement(statement->value);
  *(oCURRENT_STREAMo.get()->native_stream) << "." << ((String_Wrapper*)(statement->rest->value))->wrapper_value << " = ";
  java_output_statement(statement->rest->rest->value);
}

void java_output_implements_interfaces(Cons* interfacelist) {
  *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(interfacelist->value))->wrapper_value;
  { String_Wrapper* interface = NULL;
    Cons* iter_000 = interfacelist->rest;

    while (!(iter_000 == NIL)) {
      interface = ((String_Wrapper*)(iter_000->value));
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << ", " << interface->wrapper_value;
    }
  }
  *(oCURRENT_STREAMo.get()->native_stream) << " ";
}

void java_output_class(Cons* classdef, boolean exceptionclassP) {
  java_output_class_declaration(classdef);
  *(oCURRENT_STREAMo.get()->native_stream) << "{" << endl;
  java_bump_indent();
  java_output_class_variable_definitions(((Cons*)(classdef->nth(6))));
  java_output_class_constructors(((Cons*)(classdef->nth(7))), ((String_Wrapper*)(classdef->fourth()))->wrapper_value, exceptionclassP);
  java_output_class_methods(((Cons*)(classdef->nth(8))));
  java_unbump_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl << endl;
}

void java_output_class_declaration(Cons* classdef) {
  if (unwrap_string(((String_Wrapper*)(classdef->value))) != NULL) {
    java_output_javadoc_comment(((String_Wrapper*)(classdef->value)), NULL, NULL, "Stella Java Translator", NULL);
  }
  { Object* m = NULL;
    Cons* iter_000 = ((Cons*)(classdef->rest->value));

    while (!(iter_000 == NIL)) {
      m = iter_000->value;
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(m))->wrapper_value << " ";
    }
  }
  *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(classdef->rest->rest->value))->wrapper_value << " " << ((String_Wrapper*)(classdef->fourth()))->wrapper_value << " ";
  if (((boolean)(classdef->fifth()))) {
    *(oCURRENT_STREAMo.get()->native_stream) << "extends " << ((String_Wrapper*)(classdef->fifth()))->wrapper_value << " ";
  }
  if (!(((Cons*)(classdef->nth(5))) == NIL)) {
    *(oCURRENT_STREAMo.get()->native_stream) << "implements ";
    java_output_implements_interfaces(((Cons*)(classdef->nth(5))));
  }
}

void java_output_class_variable_definitions(Cons* variabletranslations) {
  { Object* statement = NULL;
    Cons* iter_000 = variabletranslations;

    while (!(iter_000 == NIL)) {
      statement = iter_000->value;
      iter_000 = iter_000->rest;
      java_output_statement(((Cons*)(statement)));
    }
  }
}

void java_output_class_constructors(Cons* constructors, char* classname, boolean exceptionclassP) {
  if (exceptionclassP) {
    java_output_exception_constructor(classname);
  }
  { Translation_Unit* statement = NULL;
    Cons* iter_000 = constructors;

    while (!(iter_000 == NIL)) {
      statement = ((Translation_Unit*)(iter_000->value));
      iter_000 = iter_000->rest;
      java_output_statement(java_translate_unit(statement));
      statement->translation = NULL;
      statement->code_register = NULL;
    }
  }
}

void java_output_class_methods(Cons* methods) {
  { Translation_Unit* statement = NULL;
    Cons* iter_000 = methods;

    while (!(iter_000 == NIL)) {
      statement = ((Translation_Unit*)(iter_000->value));
      iter_000 = iter_000->rest;
      java_output_statement(java_translate_unit(statement));
      statement->translation = NULL;
      statement->code_register = NULL;
    }
  }
}

void java_output_exception_constructor(char* exceptionname) {
  java_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "public " << exceptionname << " (String message) {" << endl;
  java_bump_indent();
  java_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "super(message);" << endl;
  java_unbump_indent();
  java_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl << endl;
}

void java_output_named_statement(Cons* namedstatement) {
  java_output_statement(namedstatement->value);
  *(oCURRENT_STREAMo.get()->native_stream) << " : ";
  java_output_statement(namedstatement->rest->value);
}

void java_output_formal_parameters(Cons* parameters) {
  *(oCURRENT_STREAMo.get()->native_stream) << "(";
  if (!(parameters == NIL)) {
    *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(((Cons*)(parameters->value))->value))->wrapper_value << " " << ((String_Wrapper*)(((Cons*)(parameters->value))->rest->value))->wrapper_value;
    { Cons* parameter = NULL;
      Cons* iter_000 = parameters->rest;

      while (!(iter_000 == NIL)) {
        parameter = ((Cons*)(iter_000->value));
        iter_000 = iter_000->rest;
        *(oCURRENT_STREAMo.get()->native_stream) << ", " << ((String_Wrapper*)(parameter->value))->wrapper_value << " " << ((String_Wrapper*)(parameter->rest->value))->wrapper_value;
      }
    }
  }
  *(oCURRENT_STREAMo.get()->native_stream) << ")";
}

void java_output_method_signature(Cons* method) {
  { Object* m = NULL;
    Cons* iter_000 = ((Cons*)(method->value));

    while (!(iter_000 == NIL)) {
      m = iter_000->value;
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(m))->wrapper_value << " ";
    }
  }
  java_output_type_expression(((Cons*)(method->rest->value)));
  *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(method->rest->rest->value))->wrapper_value;
  java_output_formal_parameters(((Cons*)(method->fourth())));
}

Cons* java_separate_comment_from_body(Cons* body, Cons*& _return1) {
  if ((body->value == SYM_JAVA_OUTPUT_STELLA_JAVA_STATEMENTS) &&
      ((!(body->rest == NIL)) &&
       (isaP(body->rest->value, SGT_JAVA_OUTPUT_STELLA_CONS) &&
        (((Cons*)(body->rest->value))->value == SYM_JAVA_OUTPUT_STELLA_JAVA_COMMENT)))) {
    { Object* comment = body->rest->value;

      body->rest = body->rest->rest;
      _return1 = ((Cons*)(comment));
      return (body);
    }
  }
  else {
    _return1 = NULL;
    return (body);
  }
}

void java_output_method(Cons* method) {
  { Cons* body = NULL;
    Cons* comment = NULL;

    body = java_separate_comment_from_body(((Cons*)(method->fifth())), comment);
    if (((boolean)(comment))) {
      java_indent();
      java_output_javadoc_comment(((String_Wrapper*)(comment->rest->value)), ((Cons*)(method->fourth())), ((String_Wrapper*)(((Cons*)(method->rest->value))->value)), NULL, NULL);
    }
    java_indent();
    java_output_method_signature(method);
    if (body == NIL) {
      {
        if (!(((Cons*)(method->value))->memberP(wrap_string("abstract")))) {
          *(STANDARD_WARNING->native_stream) << "Warning: " << "Method " << "`" << method->rest->rest->value << "'" << " has an empty body but is not abstract!" << endl;
        }
        *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
      }
    }
    else {
      {
        *(oCURRENT_STREAMo.get()->native_stream) << " {" << endl;
        java_bump_indent();
        java_output_statement(body);
        java_unbump_indent();
        java_indent();
        *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
      }
    }
    *(oCURRENT_STREAMo.get()->native_stream) << endl;
  }
}

void Cons::java_output_literal() {
  { Cons* cons = this;

    if (cons == NIL) {
      *(oCURRENT_STREAMo.get()->native_stream) << "NIL";
    }
    else {
      {
        *(oCURRENT_STREAMo.get()->native_stream) << "(" << cons->value << " . ";
        cons->rest->java_output_literal();
      }
    }
  }
}

void Quoted_Expression::java_output_literal() {
  { Quoted_Expression* tree = this;

    *(oCURRENT_STREAMo.get()->native_stream) << "\"" << tree << "\"";
  }
}

void Symbol::java_output_literal() {
  { Symbol* symbol = this;

    *(oCURRENT_STREAMo.get()->native_stream) << java_translate_symbol_name(symbol)->wrapper_value;
  }
}

void Surrogate::java_output_literal() {
  { Surrogate* surrogate = this;

    *(oCURRENT_STREAMo.get()->native_stream) << java_translate_surrogate_name(surrogate)->wrapper_value;
  }
}

void Keyword::java_output_literal() {
  { Keyword* keyword = this;

    *(oCURRENT_STREAMo.get()->native_stream) << java_translate_keyword_name(keyword)->wrapper_value;
  }
}

void java_output_type_expression(Cons* typeexpression) {
  { String_Wrapper* typeexpr = NULL;
    Cons* iter_000 = typeexpression;

    while (!(iter_000 == NIL)) {
      typeexpr = ((String_Wrapper*)(iter_000->value));
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << typeexpr->wrapper_value << " ";
    }
  }
}

Cons* oJAVA_SEMICOLON_STATEMENTSo = NULL;

boolean java_output_semicolonP(Cons* statement) {
  if (((boolean)(statement))) {
    return (oJAVA_SEMICOLON_STATEMENTSo->memberP(statement->value));
  }
  else {
    return (FALSE);
  }
}

boolean java_indent_statementP(Cons* statement) {
  if (((boolean)(statement))) {
    return (!get_quoted_tree("((JAVA_STATEMENTS JAVA_CATCH) \"/STELLA\")", "/STELLA")->memberP(statement->value));
  }
  else {
    return (FALSE);
  }
}

boolean java_illegal_statementP(Cons* statement) {
  if (((boolean)(statement))) {
    return (get_quoted_tree("((JAVA_LITERAL JAVA_IDENT) \"/STELLA\")", "/STELLA")->memberP(statement->value));
  }
  else {
    return (FALSE);
  }
}

void java_output_statements(Cons* statementlist) {
  { Object* statement = NULL;
    Cons* iter_000 = statementlist;

    while (!(iter_000 == NIL)) {
      statement = iter_000->value;
      iter_000 = iter_000->rest;
      if (!(java_illegal_statementP(((Cons*)(statement))))) {
        if (java_indent_statementP(((Cons*)(statement)))) {
          java_indent();
        }
        java_output_statement(statement);
        if (java_output_semicolonP(((Cons*)(statement)))) {
          *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
        }
      }
    }
  }
}

void java_output_declarations(Cons* declarations) {
  java_bump_indent();
  { Cons* declaration = NULL;
    Cons* iter_000 = declarations;

    while (!(iter_000 == NIL)) {
      declaration = ((Cons*)(iter_000->value));
      iter_000 = iter_000->rest;
      java_indent();
      java_output_type_expression(((Cons*)(declaration->value)));
      *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(declaration->rest->value))->wrapper_value;
      *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
    }
  }
  *(oCURRENT_STREAMo.get()->native_stream) << endl;
  java_unbump_indent();
}

char* java_heuristically_translate_name(char* stella_name, Cons* case_converted_name_list) {
  { String_Wrapper* pname = NULL;
    Cons* iter_000 = case_converted_name_list;

    while (!(iter_000 == NIL)) {
      pname = ((String_Wrapper*)(iter_000->value));
      iter_000 = iter_000->rest;
      if (string_equalP(pname->wrapper_value, stella_name)) {
        return (pname->wrapper_value);
      }
    }
  }
  { boolean test_value_000 = FALSE;

    if (oMODULEo.get()->case_sensitiveP) {
      test_value_000 = TRUE;
    }
    else {
      { boolean foundP_000 = FALSE;

        { char ch = NULL_CHARACTER;
          char* vector_000 = stella_name;
          int index_000 = 0;
          int length_000 = strlen(vector_000);

          while (index_000 < length_000) {
            ch = vector_000[index_000];
            index_000 = index_000 + 1;
            if (upper_case_characterP(ch)) {
              foundP_000 = TRUE;
              break;
            }
          }
        }
        test_value_000 = foundP_000;
      }
    }
    if (test_value_000) {
      {
        return (java_translate_namestring(make_matching_name_full(stella_name, KWD_JAVA_OUTPUT_NO, KWD_JAVA_OUTPUT_NO, "- ", "", "", "", "", KWD_JAVA_OUTPUT_PRESERVE, "_")));
      }
    }
    else {
      if (string_memberP(stella_name, '*')) {
        {
          return (java_translate_namestring(make_matching_name_full(stella_name, KWD_JAVA_OUTPUT_CLEVER, KWD_JAVA_OUTPUT_CLEVER, "- ", "", "", "", "", KWD_JAVA_OUTPUT_UPCASE, "_")));
        }
      }
      else {
        {
          return (java_translate_namestring(make_matching_name_full(stella_name, KWD_JAVA_OUTPUT_CLEVER, KWD_JAVA_OUTPUT_CLEVER, "- ", "", "", "", "", KWD_JAVA_OUTPUT_TITLECASEX, "")));
        }
      }
    }
  }
}

void java_output_comment_string(char* comment, char* comment_start, char* comment_continuation, char* comment_end, boolean javadoc_commentP, Cons* case_converted_name_list) {
  { boolean returnP = FALSE;
    boolean escapeP = FALSE;
    boolean inside_quoteP = FALSE;
    Output_Stream* saved_stream = oCURRENT_STREAMo.get();
    Output_String_Stream* string_stream = NULL;
    char* stella_name = NULL;

    *(oCURRENT_STREAMo.get()->native_stream) << comment_start;
    { char renamed_Char = NULL_CHARACTER;
      char* vector_000 = comment;
      int index_000 = 0;
      int length_000 = strlen(vector_000);

      while (index_000 < length_000) {
        renamed_Char = vector_000[index_000];
        index_000 = index_000 + 1;
        switch (renamed_Char) {
          case '\n': 
            if (!(returnP)) {
              *(oCURRENT_STREAMo.get()->native_stream) << endl;
              java_indent();
              *(oCURRENT_STREAMo.get()->native_stream) << comment_continuation;
            }
          break;
          case '\r': 
            *(oCURRENT_STREAMo.get()->native_stream) << endl;
            java_indent();
            *(oCURRENT_STREAMo.get()->native_stream) << comment_continuation;
            returnP = TRUE;
            escapeP = FALSE;
            continue;
          break;
          case '`': 
            if (escapeP) {
              *(oCURRENT_STREAMo.get()->native_stream) << renamed_Char;
            }
            else if (inside_quoteP) {
              *(STANDARD_WARNING->native_stream) << "Warning: " << "Encountered unescaped ` inside ` form in comment " << "`" << comment << "'" << endl;
              *(oCURRENT_STREAMo.get()->native_stream) << renamed_Char;
            }
            else {
              string_stream = new_output_string_stream();
              oCURRENT_STREAMo.set(string_stream);
              inside_quoteP = TRUE;
            }
          break;
          case '\'': 
            if (escapeP) {
              *(oCURRENT_STREAMo.get()->native_stream) << renamed_Char;
            }
            else if (inside_quoteP) {
              oCURRENT_STREAMo.set(saved_stream);
              stella_name = string_stream->the_string_reader();
              if (javadoc_commentP) {
                *(oCURRENT_STREAMo.get()->native_stream) << "<code>";
              }
              else {
                *(oCURRENT_STREAMo.get()->native_stream) << "`";
              }
              *(oCURRENT_STREAMo.get()->native_stream) << java_heuristically_translate_name(stella_name, case_converted_name_list);
              if (javadoc_commentP) {
                *(oCURRENT_STREAMo.get()->native_stream) << "</code>";
              }
              else {
                *(oCURRENT_STREAMo.get()->native_stream) << "'";
              }
              inside_quoteP = FALSE;
            }
            else {
              *(oCURRENT_STREAMo.get()->native_stream) << renamed_Char;
            }
          break;
          case '\\': 
            if (escapeP) {
              *(oCURRENT_STREAMo.get()->native_stream) << renamed_Char;
            }
            else {
              {
                escapeP = TRUE;
                returnP = FALSE;
                continue;
              }
            }
          break;
          default:
            if (inside_quoteP ||
                (!javadoc_commentP)) {
              *(oCURRENT_STREAMo.get()->native_stream) << renamed_Char;
            }
            else {
              write_html_character_quoting_special_characters(oCURRENT_STREAMo.get()->native_stream, renamed_Char);
            }
            returnP = FALSE;
            escapeP = FALSE;
          break;
        }
      }
    }
    if ((comment_end != NULL) &&
        (!string_eqlP(comment_end, ""))) {
      {
        java_indent();
        *(oCURRENT_STREAMo.get()->native_stream) << comment_end;
      }
    }
    else {
      *(oCURRENT_STREAMo.get()->native_stream) << endl;
    }
  }
}

void java_output_comment(String_Wrapper* tree) {
  java_output_comment_string(tree->wrapper_value, "// ", "// ", NULL, FALSE, NIL);
}

void java_output_javadoc_comment(String_Wrapper* tree, Cons* parameter_names_and_types, String_Wrapper* return_value, char* author, char* version) {
  { Cons* parameter_names = NIL;

    if (((boolean)(parameter_names_and_types))) {
      { Cons* n = NULL;
        Cons* iter_000 = parameter_names_and_types;
        Cons* collect_000 = NULL;

        while (!(iter_000 == NIL)) {
          n = ((Cons*)(iter_000->value));
          iter_000 = iter_000->rest;
          if (!((boolean)(collect_000))) {
            {
              collect_000 = cons(((String_Wrapper*)(n->rest->value)), NIL);
              if (parameter_names == NIL) {
                parameter_names = collect_000;
              }
              else {
                add_cons_to_end_of_cons_list(parameter_names, collect_000);
              }
            }
          }
          else {
            {
              collect_000->rest = cons(((String_Wrapper*)(n->rest->value)), NIL);
              collect_000 = collect_000->rest;
            }
          }
        }
      }
    }
    java_output_comment_string(tree->wrapper_value, "/** ", " * ", NULL, TRUE, parameter_names);
    { String_Wrapper* n = NULL;
      Cons* iter_001 = parameter_names;

      while (!(iter_001 == NIL)) {
        n = ((String_Wrapper*)(iter_001->value));
        iter_001 = iter_001->rest;
        java_indent();
        *(oCURRENT_STREAMo.get()->native_stream) << " * @param " << n->wrapper_value << endl;
      }
    }
    if (((boolean)(return_value)) &&
        (!string_eqlP(return_value->wrapper_value, "void"))) {
      java_indent();
      *(oCURRENT_STREAMo.get()->native_stream) << " * @return " << return_value->wrapper_value << endl;
    }
    if ((author != NULL) &&
        (!(author == ""))) {
      java_indent();
      *(oCURRENT_STREAMo.get()->native_stream) << " * @author " << author << endl;
    }
    if ((version != NULL) &&
        (!(version == ""))) {
      java_indent();
      *(oCURRENT_STREAMo.get()->native_stream) << " * @version " << version << endl;
    }
    java_indent();
    *(oCURRENT_STREAMo.get()->native_stream) << " */" << endl;
  }
}

void java_output_verbatim(String_Wrapper* verbatimstatement) {
  *(oCURRENT_STREAMo.get()->native_stream) << substitute_template_variables_in_string(verbatimstatement->wrapper_value, oJAVA_STELLA_PACKAGE_MAPPINGo);
}

void java_output_make(Cons* statement) {
  *(oCURRENT_STREAMo.get()->native_stream) << "new ";
  java_output_statement(statement->value);
  java_output_statement(statement->rest->value);
}

void java_output_cast(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "((" << ((String_Wrapper*)(tree->rest->value))->wrapper_value << ")(";
  java_output_statement(tree->value);
  *(oCURRENT_STREAMo.get()->native_stream) << "))";
}

void java_output_progn(Cons* progn) {
  *(oCURRENT_STREAMo.get()->native_stream) << "{" << endl;
  java_bump_indent();
  java_output_statement(progn);
  java_unbump_indent();
  java_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
}

void java_output_block(Cons* block) {
  { boolean firststatementP = TRUE;

    *(oCURRENT_STREAMo.get()->native_stream) << "{ ";
    java_bump_indent();
    { Cons* declaration = NULL;
      Cons* iter_000 = ((Cons*)(block->value));

      while (!(iter_000 == NIL)) {
        declaration = ((Cons*)(iter_000->value));
        iter_000 = iter_000->rest;
        if (!(firststatementP)) {
          java_indent();
        }
        firststatementP = FALSE;
        *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(declaration->value))->wrapper_value;
        *(oCURRENT_STREAMo.get()->native_stream) << " ";
        java_output_statement(declaration->rest->value);
        if (!(!((boolean)(declaration->rest->rest->value)))) {
          *(oCURRENT_STREAMo.get()->native_stream) << " = ";
          java_output_statement(declaration->rest->rest->value);
        }
        *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
      }
    }
    *(oCURRENT_STREAMo.get()->native_stream) << endl;
    java_output_statement(block->rest->value);
    java_unbump_indent();
    java_indent();
    *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
  }
}

void java_output_with_process_lock(Cons* synch) {
  *(oCURRENT_STREAMo.get()->native_stream) << "synchronized (";
  java_output_statement(synch->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ") ";
  java_output_progn(((Cons*)(synch->rest->value)));
}

void java_output_return(Cons* returnstatement) {
  *(oCURRENT_STREAMo.get()->native_stream) << "return";
  if (((boolean)(returnstatement))) {
    *(oCURRENT_STREAMo.get()->native_stream) << " (";
    java_output_statement(returnstatement);
    *(oCURRENT_STREAMo.get()->native_stream) << ")";
  }
}

void java_output_throw(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "throw new ";
  *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(tree->value))->wrapper_value;
}

void java_output_catch(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << " catch (";
  *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(((Cons*)(tree->value))->value))->wrapper_value;
  *(oCURRENT_STREAMo.get()->native_stream) << " ";
  *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(((Cons*)(tree->value))->rest->value))->wrapper_value;
  *(oCURRENT_STREAMo.get()->native_stream) << ") {" << endl;
  java_bump_indent();
  java_output_statements(tree->rest);
  java_unbump_indent();
  java_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "}";
}

void java_output_unwind_protect(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "try {" << endl;
  java_bump_indent();
  if (java_prognP(tree->value)) {
    java_output_statement(((Cons*)(tree->value))->rest->value);
  }
  else if (java_indent_statementP(((Cons*)(tree->value)))) {
    java_indent();
    java_output_statement(tree->value);
    if (java_output_semicolonP(((Cons*)(tree->value)))) {
      *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
    }
  }
  else {
    java_output_statement(tree->value);
  }
  java_unbump_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << endl;
  java_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "} finally {" << endl;
  java_bump_indent();
  java_output_statements(tree->rest);
  java_unbump_indent();
  java_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
}

void java_output_handler_case(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "try {" << endl;
  java_bump_indent();
  if (java_prognP(tree->value)) {
    java_output_statement(((Cons*)(tree->value))->rest->value);
  }
  else {
    {
      java_indent();
      java_output_statement(tree->value);
      if (java_output_semicolonP(((Cons*)(tree->value)))) {
        *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
      }
    }
  }
  java_unbump_indent();
  java_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "}";
  java_output_statements(tree->rest);
  *(oCURRENT_STREAMo.get()->native_stream) << endl;
}

void java_output_signal(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "throw ";
  java_output_statement(tree->value);
}

void java_output_global_definition(Cons* global) {
  if (((String_Wrapper*)(global->value))->wrapper_value != NULL) {
    java_indent();
    java_output_javadoc_comment(((String_Wrapper*)(global->value)), NIL, NULL, NULL, NULL);
  }
  java_indent();
  java_output_statement(global->rest->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(global->rest->rest->value))->wrapper_value;
  if (!(global->rest->rest->rest == NIL)) {
    *(oCURRENT_STREAMo.get()->native_stream) << " = ";
    java_output_statement(global->fourth());
  }
  *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl << endl;
}

void java_output_special_definition(Cons* special) {
  if (((boolean)(special->value))) {
    java_indent();
    java_output_javadoc_comment(((String_Wrapper*)(special->value)), NIL, NULL, NULL, NULL);
  }
  java_indent();
  java_output_statement(special->rest->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(special->rest->rest->value))->wrapper_value;
  *(oCURRENT_STREAMo.get()->native_stream) << " = new InheritableThreadLocal();" << endl << endl;
  if (!(special->rest->rest->rest == NIL)) {
    { Output_String_Stream* stream_000 = new_output_string_stream();

      *(stream_000->native_stream) << "Special variables in Java shouldn't have initial values:" << "`" << special << "'";
      throw *new_stella_exception(stream_000->the_string_reader());
    }
  }
}

void java_output_actuals_as_cons_expression(Cons* arglist) {
  if (arglist == NIL) {
    *(oCURRENT_STREAMo.get()->native_stream) << java_prepend_global_class_name("NIL", oSTELLA_MODULEo);
  }
  else {
    {
      *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(oJAVA_STELLA_PACKAGE_MAPPINGo->lookup(wrap_string("STELLAROOT")))) << ".Stella_Object.cons(";
      java_output_statement(arglist->value);
      *(oCURRENT_STREAMo.get()->native_stream) << ", ";
      java_output_actuals_as_cons_expression(arglist->rest);
      *(oCURRENT_STREAMo.get()->native_stream) << ")";
    }
  }
}

void java_output_funcall(Cons* funcall) {
  *(oCURRENT_STREAMo.get()->native_stream) << java_yield_full_native_class_name() << ".funcall(";
  java_output_statement(funcall->rest->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ", null, new java.lang.Object [] ";
  java_output_array(((Cons*)(funcall->rest->rest->value))->rest);
  *(oCURRENT_STREAMo.get()->native_stream) << ")";
}

void java_output_method_code_call(Cons* methodcall) {
  *(oCURRENT_STREAMo.get()->native_stream) << java_yield_full_native_class_name() << ".funcall(";
  java_output_statement(methodcall->rest->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ", ";
  java_output_statement(methodcall->rest->rest->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ", new java.lang.Object []";
  java_output_array(((Cons*)(methodcall->fourth()))->rest);
  *(oCURRENT_STREAMo.get()->native_stream) << ")";
}

void java_output_break(Cons* tag) {
  *(oCURRENT_STREAMo.get()->native_stream) << "break ";
  java_output_statement(tag);
  *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
}

void java_output_continue(Cons* tag) {
  *(oCURRENT_STREAMo.get()->native_stream) << "continue ";
  java_output_statement(tag);
  *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
}

boolean java_statement_returnsP(Cons* statement) {
  if (!((boolean)(statement))) {
    return (FALSE);
  }
  else if (statement == NIL) {
    return (FALSE);
  }
  else {
    { Generalized_Symbol* test_value_000 = ((Generalized_Symbol*)(statement->value));

      if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_VERBATIM) {
        return (string_search(((String_Wrapper*)(statement->rest->value))->wrapper_value, "throw new Error", 0) != NULL_INTEGER);
      }
      else if ((test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_RETURN) ||
          ((test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_CONTINUE) ||
           ((test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_BREAK) ||
            (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_SIGNAL)))) {
        return (TRUE);
      }
      else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_STATEMENTS) {
        return (java_last_statement_returnsP(statement->rest));
      }
      else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_PROGN) {
        return (java_last_statement_returnsP(((Cons*)(statement->rest->value))));
      }
      else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_BLOCK) {
        return (java_last_statement_returnsP(((Cons*)(statement->rest->rest->value))));
      }
      else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_IF) {
        return (java_statement_returnsP(((Cons*)(statement->rest->rest->value))) &&
            java_statement_returnsP(((Cons*)(statement->fourth()))));
      }
      else if (test_value_000 == SYM_JAVA_OUTPUT_STELLA_JAVA_COND) {
        { boolean test_value_001 = FALSE;

          test_value_001 = java_statement_returnsP(((Cons*)(statement->rest->value)));
          if (test_value_001) {
            { boolean alwaysP_000 = TRUE;

              { Object* c = NULL;
                Cons* iter_000 = ((Cons*)(statement->rest->rest->value));

                while (!(iter_000 == NIL)) {
                  c = iter_000->value;
                  iter_000 = iter_000->rest;
                  if (!java_last_statement_returnsP(((Cons*)(c)))) {
                    alwaysP_000 = FALSE;
                    break;
                  }
                }
              }
              test_value_001 = alwaysP_000;
            }
          }
          { boolean value_000 = test_value_001;

            return (value_000);
          }
        }
      }
      else {
        return (FALSE);
      }
    }
  }
}

boolean java_last_statement_returnsP(Cons* statements) {
  { Object* last_statement = statements->last();

    return (isaP(last_statement, SGT_JAVA_OUTPUT_STELLA_CONS) &&
        java_statement_returnsP(((Cons*)(last_statement))));
  }
}

void java_output_case(Cons* renamed_Case) {
  { Object* keyform = renamed_Case->value;
    Object* defaultcase = renamed_Case->rest->value;
    Object* conditions = renamed_Case->rest->rest->value;

    *(oCURRENT_STREAMo.get()->native_stream) << "switch (";
    java_output_statement(keyform);
    *(oCURRENT_STREAMo.get()->native_stream) << ") {" << endl;
    java_bump_indent();
    { Cons* c = NULL;
      Cons* iter_000 = ((Cons*)(conditions));

      while (!(iter_000 == NIL)) {
        c = ((Cons*)(iter_000->value));
        iter_000 = iter_000->rest;
        { Cons* condition = c;

          { Object* cond = NULL;
            Cons* iter_001 = ((Cons*)((consP(((Cons*)(condition->value))->value) ? condition->value : cons(condition->value, NIL))));

            while (!(iter_001 == NIL)) {
              cond = iter_001->value;
              iter_001 = iter_001->rest;
              java_indent();
              *(oCURRENT_STREAMo.get()->native_stream) << "case ";
              java_output_statement(cond);
              *(oCURRENT_STREAMo.get()->native_stream) << ": " << endl;
            }
          }
          java_bump_indent();
          java_output_statement(condition->rest->value);
          java_unbump_indent();
          if (!(java_last_statement_returnsP(((Cons*)(condition->rest->value))))) {
            java_indent();
            *(oCURRENT_STREAMo.get()->native_stream) << "break;" << endl;
          }
        }
      }
    }
    if (!((boolean)(defaultcase))) {
      cerr << "Safety violation: " << "INTERNAL ERROR: `java-output-case' expects an `otherwise' clause.";
    }
    java_indent();
    *(oCURRENT_STREAMo.get()->native_stream) << "default:" << endl;
    java_bump_indent();
    java_output_statement(defaultcase);
    java_unbump_indent();
    if (!(java_last_statement_returnsP(((Cons*)(defaultcase))))) {
      java_indent();
      *(oCURRENT_STREAMo.get()->native_stream) << "break;" << endl;
    }
    java_unbump_indent();
    java_indent();
    *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
  }
}

void java_output_cond(Cons* cond) {
  { Cons* defaultcondition = ((Cons*)(cond->value));
    Cons* conditions = ((Cons*)(cond->rest->value));
    Cons* firstcondition = ((Cons*)(conditions->value));
    Cons* restconditions = conditions->rest;

    if (((boolean)(defaultcondition)) &&
        (conditions == NIL)) {
      *(oCURRENT_STREAMo.get()->native_stream) << "if (true) ";
      java_output_statement(defaultcondition);
      return;
    }
    *(oCURRENT_STREAMo.get()->native_stream) << "if (";
    java_output_statement(firstcondition->value);
    *(oCURRENT_STREAMo.get()->native_stream) << ") ";
    java_output_statement(firstcondition->rest->value);
    { Object* c = NULL;
      Cons* iter_000 = restconditions;

      while (!(iter_000 == NIL)) {
        c = iter_000->value;
        iter_000 = iter_000->rest;
        { Cons* condition = ((Cons*)(c));

          java_indent();
          *(oCURRENT_STREAMo.get()->native_stream) << "else if (";
          java_output_statement(condition->value);
          *(oCURRENT_STREAMo.get()->native_stream) << ") ";
          java_output_statement(condition->rest->value);
        }
      }
    }
    if (((boolean)(defaultcondition))) {
      java_indent();
      *(oCURRENT_STREAMo.get()->native_stream) << "else ";
      java_output_statement(defaultcondition);
    }
  }
}

boolean java_prognP(Object* tree) {
  return (consP(tree) &&
      (((Cons*)(tree))->value == SYM_JAVA_OUTPUT_STELLA_JAVA_PROGN));
}

boolean java_blockP(Object* tree) {
  return (consP(tree) &&
      (((Cons*)(tree))->value == SYM_JAVA_OUTPUT_STELLA_JAVA_BLOCK));
}

void java_output_if(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "if (";
  java_output_statement(tree->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ") ";
  if (java_prognP(tree->rest->value) ||
      java_blockP(tree->rest->value)) {
    java_output_statement(tree->rest->value);
  }
  else {
    {
      *(oCURRENT_STREAMo.get()->native_stream) << endl;
      java_bump_indent();
      java_indent();
      java_output_statement(tree->rest->value);
      *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
      java_unbump_indent();
    }
  }
  if (!(!((boolean)(tree->rest->rest->value)))) {
    java_indent();
    *(oCURRENT_STREAMo.get()->native_stream) << "else ";
    if (java_prognP(tree->rest->rest->value) ||
        java_blockP(tree->rest->rest->value)) {
      java_output_statement(tree->rest->rest->value);
    }
    else {
      {
        *(oCURRENT_STREAMo.get()->native_stream) << endl;
        java_bump_indent();
        java_indent();
        java_output_statement(tree->rest->rest->value);
        *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
        java_unbump_indent();
      }
    }
  }
}

void java_output_when(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "if (";
  java_output_statement(tree->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ") {" << endl;
  java_bump_indent();
  java_output_statement(tree->rest->value);
  java_unbump_indent();
  java_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
}

void java_output_unless(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "if (!(";
  java_output_statement(tree->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ")) {" << endl;
  java_bump_indent();
  java_output_statement(tree->rest->value);
  java_unbump_indent();
  java_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
}

void java_output_assignment(Cons* assignment) {
  java_output_statement(assignment->value);
  *(oCURRENT_STREAMo.get()->native_stream) << " = ";
  java_output_statement(assignment->rest->value);
}

void java_output_loop(Cons* loop) {
  *(oCURRENT_STREAMo.get()->native_stream) << "for (;;) ";
  java_output_statement(loop->value);
}

void java_output_while(Cons* loop) {
  *(oCURRENT_STREAMo.get()->native_stream) << "while (";
  java_output_statement(loop->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ") ";
  java_output_statement(loop->rest->value);
}

void java_output_foreach(Cons* loop) {
  { Object* continuationtest = loop->value;
    Object* nextassignments = loop->rest->value;
    Object* body = loop->rest->rest->value;

    *(oCURRENT_STREAMo.get()->native_stream) << "while (";
    java_output_statement(continuationtest);
    *(oCURRENT_STREAMo.get()->native_stream) << ") {" << endl;
    java_bump_indent();
    java_output_statements(((Cons*)(nextassignments)));
    java_output_statements(((Cons*)(body)));
    java_unbump_indent();
    java_indent();
    *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
  }
}

boolean java_end_of_line_tokenP(Object* token) {
  if (safe_primary_type(token) == SGT_JAVA_OUTPUT_STELLA_CONS) {
    { Object* token_000 = token;
      Cons* token = ((Cons*)(token_000));

      return (token->value == SYM_JAVA_OUTPUT_STELLA_JAVA_EOL);
    }
  }
  else {
  }
  return (FALSE);
}

void java_output_print_stream(Cons* exps, boolean nativestreamP) {
  { Object* stream = exps->value;

    { boolean foundP_000 = FALSE;

      { Object* i = NULL;
        Iterator* iter_000 = exps->rest->but_last();

        while (iter_000->nextP()) {
          i = iter_000->value;
          if (java_end_of_line_tokenP(i)) {
            foundP_000 = TRUE;
            break;
          }
        }
      }
      { boolean embeddedeolP = foundP_000;
        Cons* printitems = NIL;

        if (embeddedeolP) {
          *(oCURRENT_STREAMo.get()->native_stream) << "{" << endl;
          java_bump_indent();
        }
        { Cons_Iterator* it = exps->rest->allocate_iterator();

          while (it->nextP()) {
            { Object* item = it->value;

              if (java_end_of_line_tokenP(item)) {
                {
                  if (embeddedeolP) {
                    java_indent();
                  }
                  java_help_output_print_stream(stream, printitems->reverse(), nativestreamP, TRUE);
                  if (embeddedeolP) {
                    *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
                  }
                  printitems = NIL;
                }
              }
              else {
                printitems = cons(item, printitems);
              }
            }
          }
        }
        if (!(printitems == NIL)) {
          if (embeddedeolP) {
            java_indent();
          }
          java_help_output_print_stream(stream, printitems->reverse(), nativestreamP, FALSE);
          if (embeddedeolP) {
            *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
          }
        }
        if (embeddedeolP) {
          java_unbump_indent();
          java_indent();
          *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
        }
      }
    }
  }
}

void java_help_output_print_stream(Object* stream, Cons* exps, boolean nativestreamP, boolean endoflineP) {
  if (stream == SYM_JAVA_OUTPUT_STELLA_JAVA_STANDARD_OUT) {
    *(oCURRENT_STREAMo.get()->native_stream) << "java.lang.System.out";
  }
  else if (stream == SYM_JAVA_OUTPUT_STELLA_JAVA_STANDARD_ERROR) {
    *(oCURRENT_STREAMo.get()->native_stream) << "java.lang.System.err";
  }
  else {
    java_output_statement(stream);
    if (!nativestreamP) {
      *(oCURRENT_STREAMo.get()->native_stream) << ".nativeStream";
    }
  }
  *(oCURRENT_STREAMo.get()->native_stream) << ((endoflineP ? (char*)".println(" : (char*)".print("));
  java_maybe_output_statement_with_parentheses(exps->value);
  { Object* e = NULL;
    Cons* iter_000 = exps->rest;

    while (!(iter_000 == NIL)) {
      e = iter_000->value;
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << " + ";
      java_maybe_output_statement_with_parentheses(e);
    }
  }
  *(oCURRENT_STREAMo.get()->native_stream) << ")";
}

boolean java_indentable_binary_operatorP(String_Wrapper* renamed_Operator) {
  return (get_quoted_tree("((\"||\" \"&&\") \"/STELLA\")", "/STELLA")->memberP(renamed_Operator));
}

boolean java_commutative_binary_operatorP(String_Wrapper* renamed_Operator) {
  return (get_quoted_tree("((\"+\" \"*\") \"/STELLA\")", "/STELLA")->memberP(renamed_Operator));
}

boolean java_binary_operatorP(Object* statement) {
  return (consP(statement) &&
      (SYM_JAVA_OUTPUT_STELLA_JAVA_BINARY_OP == ((Cons*)(statement))->value));
}

boolean java_operatorP(Object* statement) {
  return (consP(statement) &&
      get_quoted_tree("((JAVA_UNARY_OP JAVA_BINARY_OP JAVA_TERNARY_OP JAVA_ASSIGN JAVA_SLOT_VALUE_SETTER) \"/STELLA\")", "/STELLA")->memberP(((Cons*)(statement))->value));
}

void java_output_unary_operator(Cons* expression) {
  { String_Wrapper* op = ((String_Wrapper*)(expression->value));
    Object* arg = expression->rest->value;

    *(oCURRENT_STREAMo.get()->native_stream) << op->wrapper_value;
    java_maybe_output_statement_with_parentheses(arg);
  }
}

boolean java_nested_operator_needs_parenthesesP(String_Wrapper* op, Object* nested) {
  return (java_operatorP(nested) &&
      (!(java_commutative_binary_operatorP(op) &&
      string_eqlP(op->wrapper_value, ((String_Wrapper*)(((Cons*)(nested))->rest->rest->value))->wrapper_value))));
}

void java_help_output_binary_operator(Cons* expression, int nestlevel) {
  { Object* arg1 = expression->value;
    String_Wrapper* op = ((String_Wrapper*)(expression->rest->value));
    Object* arg2 = expression->rest->rest->value;

    if (java_nested_operator_needs_parenthesesP(op, arg1)) {
      *(oCURRENT_STREAMo.get()->native_stream) << "(";
    }
    if (java_binary_operatorP(op)) {
      java_help_output_binary_operator(((Cons*)(arg1))->rest, nestlevel + 1);
    }
    else {
      java_output_statement(arg1);
    }
    if (java_nested_operator_needs_parenthesesP(op, arg1)) {
      *(oCURRENT_STREAMo.get()->native_stream) << ")";
    }
    *(oCURRENT_STREAMo.get()->native_stream) << " ";
    *(oCURRENT_STREAMo.get()->native_stream) << op->wrapper_value;
    if (java_indentable_binary_operatorP(op)) {
      {
        *(oCURRENT_STREAMo.get()->native_stream) << endl;
        java_indent();
        *(oCURRENT_STREAMo.get()->native_stream) << "    ";
        { int d = NULL_INTEGER;
          int iter_000 = 1;
          int upper_bound_000 = nestlevel;
          boolean unboundedP_000 = upper_bound_000 == NULL_INTEGER;

          while (unboundedP_000 ||
              (iter_000 <= upper_bound_000)) {
            d = iter_000;
            iter_000 = iter_000 + 1;
            *(oCURRENT_STREAMo.get()->native_stream) << " ";
          }
        }
      }
    }
    else {
      *(oCURRENT_STREAMo.get()->native_stream) << " ";
    }
    if (java_nested_operator_needs_parenthesesP(op, arg2)) {
      *(oCURRENT_STREAMo.get()->native_stream) << "(";
    }
    if (java_binary_operatorP(arg2)) {
      java_help_output_binary_operator(((Cons*)(arg2))->rest, nestlevel + 1);
    }
    else {
      java_output_statement(arg2);
    }
    if (java_nested_operator_needs_parenthesesP(op, arg2)) {
      *(oCURRENT_STREAMo.get()->native_stream) << ")";
    }
  }
}

void java_output_binary_operator(Cons* expression) {
  java_help_output_binary_operator(expression, 0);
}

void java_output_ternary_operator(Cons* expression) {
  { Object* arg1 = expression->value;
    String_Wrapper* op1 = ((String_Wrapper*)(expression->rest->value));
    Object* arg2 = expression->rest->rest->value;
    String_Wrapper* op2 = ((String_Wrapper*)(expression->fourth()));
    Object* arg3 = expression->fifth();

    *(oCURRENT_STREAMo.get()->native_stream) << "(";
    java_maybe_output_statement_with_parentheses(arg1);
    *(oCURRENT_STREAMo.get()->native_stream) << " ";
    *(oCURRENT_STREAMo.get()->native_stream) << op1->wrapper_value;
    *(oCURRENT_STREAMo.get()->native_stream) << " ";
    java_maybe_output_statement_with_parentheses(arg2);
    *(oCURRENT_STREAMo.get()->native_stream) << " ";
    *(oCURRENT_STREAMo.get()->native_stream) << op2->wrapper_value;
    *(oCURRENT_STREAMo.get()->native_stream) << " ";
    java_maybe_output_statement_with_parentheses(arg3);
    *(oCURRENT_STREAMo.get()->native_stream) << ")";
  }
}

void java_output_method_call(Cons* methodcall) {
  java_maybe_output_statement_with_parentheses(methodcall->rest->rest->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ".";
  java_output_statement(methodcall->rest->value);
  java_output_statement(methodcall->fourth());
}

void java_output_function_call(Cons* functioncall) {
  java_maybe_output_statement_with_parentheses(functioncall->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ".";
  java_output_statement(functioncall->rest->value);
  java_output_statement(functioncall->rest->rest->value);
}

void java_output_actual_parameters(Cons* parameters) {
  *(oCURRENT_STREAMo.get()->native_stream) << "(";
  if (((boolean)(parameters->value))) {
    java_output_statement(parameters->value);
  }
  { Object* parameter = NULL;
    Cons* iter_000 = parameters->rest;

    while (!(iter_000 == NIL)) {
      parameter = iter_000->value;
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << ", ";
      java_output_statement(parameter);
    }
  }
  *(oCURRENT_STREAMo.get()->native_stream) << ")";
}

void help_startup_java_output1() {
  {
    SGT_JAVA_OUTPUT_STELLA_CONS = ((Surrogate*)(intern_rigid_symbol_wrt_module("CONS", NULL, 1)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_CLASS = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_CLASS", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_EXCEPTION_CLASS = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_EXCEPTION_CLASS", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_NAMED_STATEMENT = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_NAMED_STATEMENT", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_STATEMENTS = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_STATEMENTS", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_IDENT = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_IDENT", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_EOL = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_EOL", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_LITERAL = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_LITERAL", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_COMMENT = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_COMMENT", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_SYMBOL = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_SYMBOL", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_CATCH = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_CATCH", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_THROW = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_THROW", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_UNWIND_PROTECT = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_UNWIND_PROTECT", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_HANDLER_CASE = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_HANDLER_CASE", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_SIGNAL = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_SIGNAL", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_VERBATIM = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_VERBATIM", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_CAST = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_CAST", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_GLOBAL = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_GLOBAL", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_SPECIAL = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_SPECIAL", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_TYPE = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_TYPE", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_PROGN = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_PROGN", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_BLOCK = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_BLOCK", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_WITH_PROCESS_LOCK = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_WITH_PROCESS_LOCK", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_RETURN = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_RETURN", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_MAKE = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_MAKE", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCALL = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_FUNCALL", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_CODE_CALL = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_METHOD_CODE_CALL", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_ASSIGN = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_ASSIGN", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_BREAK = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_BREAK", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_CONTINUE = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_CONTINUE", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_COND = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_COND", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_CASE = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_CASE", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_IF = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_IF", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_WHEN = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_WHEN", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_UNLESS = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_UNLESS", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_LOOP = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_LOOP", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_WHILE = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_WHILE", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_FOREACH = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_FOREACH", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_SLOT_VALUE = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_SLOT_VALUE", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_SLOT_VALUE_SETTER = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_SLOT_VALUE_SETTER", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_UNARY_OP = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_UNARY_OP", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_BINARY_OP = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_BINARY_OP", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_TERNARY_OP = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_TERNARY_OP", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCTION_CALL = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_FUNCTION_CALL", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_CALL = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_METHOD_CALL", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_ACTUALS = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_ACTUALS", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_MAKE_ARRAY = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_MAKE_ARRAY", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_ARRAY_INITIALIZER = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_ARRAY_INITIALIZER", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_ANONYMOUS_ARRAY = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_ANONYMOUS_ARRAY", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_AREF = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_AREF", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_METHOD", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCTION = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_FUNCTION", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_PRINT_STREAM = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_PRINT_STREAM", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_PRINT_NATIVE_STREAM = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_PRINT_NATIVE_STREAM", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_DECLARATIONS = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_DECLARATIONS", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCTION_POINTER = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_FUNCTION_POINTER", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_POINTER = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_METHOD_POINTER", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_SETTER_CALL = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_METHOD_SETTER_CALL", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_NEW = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_NEW", NULL, 0)));
    KWD_JAVA_OUTPUT_NO = ((Keyword*)(intern_rigid_symbol_wrt_module("NO", NULL, 2)));
  }
}

void help_startup_java_output2() {
  {
    KWD_JAVA_OUTPUT_PRESERVE = ((Keyword*)(intern_rigid_symbol_wrt_module("PRESERVE", NULL, 2)));
    KWD_JAVA_OUTPUT_CLEVER = ((Keyword*)(intern_rigid_symbol_wrt_module("CLEVER", NULL, 2)));
    KWD_JAVA_OUTPUT_UPCASE = ((Keyword*)(intern_rigid_symbol_wrt_module("UPCASE", NULL, 2)));
    KWD_JAVA_OUTPUT_TITLECASEX = ((Keyword*)(intern_rigid_symbol_wrt_module("TITLECASEX", NULL, 2)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_STANDARD_OUT = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_STANDARD_OUT", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_JAVA_STANDARD_ERROR = ((Symbol*)(intern_rigid_symbol_wrt_module("JAVA_STANDARD_ERROR", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_STARTUP_JAVA_OUTPUT = ((Symbol*)(intern_rigid_symbol_wrt_module("STARTUP-JAVA-OUTPUT", NULL, 0)));
    SYM_JAVA_OUTPUT_STELLA_METHOD_STARTUP_CLASSNAME = ((Symbol*)(intern_rigid_symbol_wrt_module("METHOD-STARTUP-CLASSNAME", NULL, 0)));
  }
}

void help_startup_java_output3() {
  {
    define_function_object("JAVA-STELLA-PACKAGE", "(DEFUN (JAVA-STELLA-PACKAGE STRING) ())", ((cpp_function_code)(&java_stella_package)), NULL);
    define_function_object("JAVA-OUTPUT-PARSE-TREE", "(DEFUN JAVA-OUTPUT-PARSE-TREE ((CONSTREE CONS)))", ((cpp_function_code)(&java_output_parse_tree)), NULL);
    define_function_object("JAVA-BUMP-INDENT", "(DEFUN JAVA-BUMP-INDENT ())", ((cpp_function_code)(&java_bump_indent)), NULL);
    define_function_object("JAVA-UNBUMP-INDENT", "(DEFUN JAVA-UNBUMP-INDENT ())", ((cpp_function_code)(&java_unbump_indent)), NULL);
    define_function_object("JAVA-INDENT", "(DEFUN JAVA-INDENT ())", ((cpp_function_code)(&java_indent)), NULL);
    define_function_object("JAVA-OUTPUT-STATEMENT", "(DEFUN JAVA-OUTPUT-STATEMENT ((STATEMENT OBJECT)))", ((cpp_function_code)(&java_output_statement)), NULL);
    define_function_object("JAVA-MAYBE-OUTPUT-STATEMENT-WITH-PARENTHESES", "(DEFUN JAVA-MAYBE-OUTPUT-STATEMENT-WITH-PARENTHESES ((STATEMENT OBJECT)))", ((cpp_function_code)(&java_maybe_output_statement_with_parentheses)), NULL);
    define_function_object("JAVA-OUTPUT-IDENTIFIER", "(DEFUN JAVA-OUTPUT-IDENTIFIER ((IDENTIFIER STRING-WRAPPER)))", ((cpp_function_code)(&java_output_identifier)), NULL);
    define_method_object("(DEFMETHOD JAVA-OUTPUT-LITERAL ((OBJECT OBJECT)))", ((cpp_method_code)(&Object::java_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD JAVA-OUTPUT-LITERAL ((STRING STRING)))", ((cpp_method_code)(NULL)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD JAVA-OUTPUT-LITERAL ((STRING STRING-WRAPPER)))", ((cpp_method_code)(&String_Wrapper::java_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD JAVA-OUTPUT-LITERAL ((STRING MUTABLE-STRING-WRAPPER)))", ((cpp_method_code)(&Mutable_String_Wrapper::java_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD JAVA-OUTPUT-LITERAL ((CHARACTER CHARACTER-WRAPPER)))", ((cpp_method_code)(&Character_Wrapper::java_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD JAVA-OUTPUT-LITERAL ((INT INTEGER-WRAPPER)))", ((cpp_method_code)(&Integer_Wrapper::java_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD JAVA-OUTPUT-LITERAL ((FLOAT FLOAT-WRAPPER)))", ((cpp_method_code)(&Float_Wrapper::java_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD JAVA-OUTPUT-LITERAL ((BOOLEAN BOOLEAN-WRAPPER)))", ((cpp_method_code)(&Boolean_Wrapper::java_output_literal)), ((cpp_method_code)(NULL)));
    define_function_object("JAVA-OUTPUT-MAKE-ARRAY", "(DEFUN JAVA-OUTPUT-MAKE-ARRAY ((STATEMENT CONS)))", ((cpp_function_code)(&java_output_make_array)), NULL);
    define_function_object("JAVA-OUTPUT-ARRAY", "(DEFUN JAVA-OUTPUT-ARRAY ((ARRAYELEMENTS CONS)))", ((cpp_function_code)(&java_output_array)), NULL);
    define_function_object("JAVA-OUTPUT-ANONYMOUS-ARRAY", "(DEFUN JAVA-OUTPUT-ANONYMOUS-ARRAY ((STATEMENT CONS)))", ((cpp_function_code)(&java_output_anonymous_array)), NULL);
    define_function_object("JAVA-OUTPUT-AREF", "(DEFUN JAVA-OUTPUT-AREF ((STATEMENT CONS)))", ((cpp_function_code)(&java_output_aref)), NULL);
    define_function_object("JAVA-OUTPUT-SLOT-VALUE", "(DEFUN JAVA-OUTPUT-SLOT-VALUE ((STATEMENT CONS)))", ((cpp_function_code)(&java_output_slot_value)), NULL);
    define_function_object("JAVA-OUTPUT-SLOT-VALUE-SETTER", "(DEFUN JAVA-OUTPUT-SLOT-VALUE-SETTER ((STATEMENT CONS)))", ((cpp_function_code)(&java_output_slot_value_setter)), NULL);
    define_function_object("JAVA-OUTPUT-IMPLEMENTS-INTERFACES", "(DEFUN JAVA-OUTPUT-IMPLEMENTS-INTERFACES ((INTERFACELIST (CONS OF STRING-WRAPPER))))", ((cpp_function_code)(&java_output_implements_interfaces)), NULL);
    define_function_object("JAVA-OUTPUT-CLASS", "(DEFUN JAVA-OUTPUT-CLASS ((CLASSDEF CONS) (EXCEPTIONCLASS? BOOLEAN)))", ((cpp_function_code)(&java_output_class)), NULL);
    define_function_object("JAVA-OUTPUT-CLASS-DECLARATION", "(DEFUN JAVA-OUTPUT-CLASS-DECLARATION ((CLASSDEF CONS)))", ((cpp_function_code)(&java_output_class_declaration)), NULL);
    define_function_object("JAVA-OUTPUT-CLASS-VARIABLE-DEFINITIONS", "(DEFUN JAVA-OUTPUT-CLASS-VARIABLE-DEFINITIONS ((VARIABLETRANSLATIONS CONS)))", ((cpp_function_code)(&java_output_class_variable_definitions)), NULL);
    define_function_object("JAVA-OUTPUT-CLASS-CONSTRUCTORS", "(DEFUN JAVA-OUTPUT-CLASS-CONSTRUCTORS ((CONSTRUCTORS (CONS OF TRANSLATION-UNIT)) (CLASSNAME STRING) (EXCEPTIONCLASS? BOOLEAN)))", ((cpp_function_code)(&java_output_class_constructors)), NULL);
    define_function_object("JAVA-OUTPUT-CLASS-METHODS", "(DEFUN JAVA-OUTPUT-CLASS-METHODS ((METHODS (CONS OF TRANSLATION-UNIT))))", ((cpp_function_code)(&java_output_class_methods)), NULL);
    define_function_object("JAVA-OUTPUT-EXCEPTION-CONSTRUCTOR", "(DEFUN JAVA-OUTPUT-EXCEPTION-CONSTRUCTOR ((EXCEPTIONNAME STRING)))", ((cpp_function_code)(&java_output_exception_constructor)), NULL);
    define_function_object("JAVA-OUTPUT-NAMED-STATEMENT", "(DEFUN JAVA-OUTPUT-NAMED-STATEMENT ((NAMEDSTATEMENT CONS)))", ((cpp_function_code)(&java_output_named_statement)), NULL);
    define_function_object("JAVA-OUTPUT-FORMAL-PARAMETERS", "(DEFUN JAVA-OUTPUT-FORMAL-PARAMETERS ((PARAMETERS (CONS OF CONS))))", ((cpp_function_code)(&java_output_formal_parameters)), NULL);
    define_function_object("JAVA-OUTPUT-METHOD-SIGNATURE", "(DEFUN JAVA-OUTPUT-METHOD-SIGNATURE ((METHOD CONS)))", ((cpp_function_code)(&java_output_method_signature)), NULL);
    define_function_object("JAVA-SEPARATE-COMMENT-FROM-BODY", "(DEFUN (JAVA-SEPARATE-COMMENT-FROM-BODY CONS CONS) ((BODY CONS)))", ((cpp_function_code)(&java_separate_comment_from_body)), NULL);
    define_function_object("JAVA-OUTPUT-METHOD", "(DEFUN JAVA-OUTPUT-METHOD ((METHOD CONS)))", ((cpp_function_code)(&java_output_method)), NULL);
    define_method_object("(DEFMETHOD JAVA-OUTPUT-LITERAL ((CONS CONS)))", ((cpp_method_code)(&Cons::java_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD JAVA-OUTPUT-LITERAL ((TREE QUOTED-EXPRESSION)))", ((cpp_method_code)(&Quoted_Expression::java_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD JAVA-OUTPUT-LITERAL ((SYMBOL SYMBOL)))", ((cpp_method_code)(&Symbol::java_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD JAVA-OUTPUT-LITERAL ((SURROGATE SURROGATE)))", ((cpp_method_code)(&Surrogate::java_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD JAVA-OUTPUT-LITERAL ((KEYWORD KEYWORD)))", ((cpp_method_code)(&Keyword::java_output_literal)), ((cpp_method_code)(NULL)));
    define_function_object("JAVA-OUTPUT-TYPE-EXPRESSION", "(DEFUN JAVA-OUTPUT-TYPE-EXPRESSION ((TYPEEXPRESSION (CONS OF STRING-WRAPPER))))", ((cpp_function_code)(&java_output_type_expression)), NULL);
    define_function_object("JAVA-OUTPUT-SEMICOLON?", "(DEFUN (JAVA-OUTPUT-SEMICOLON? BOOLEAN) ((STATEMENT CONS)))", ((cpp_function_code)(&java_output_semicolonP)), NULL);
    define_function_object("JAVA-INDENT-STATEMENT?", "(DEFUN (JAVA-INDENT-STATEMENT? BOOLEAN) ((STATEMENT CONS)))", ((cpp_function_code)(&java_indent_statementP)), NULL);
    define_function_object("JAVA-ILLEGAL-STATEMENT?", "(DEFUN (JAVA-ILLEGAL-STATEMENT? BOOLEAN) ((STATEMENT CONS)))", ((cpp_function_code)(&java_illegal_statementP)), NULL);
    define_function_object("JAVA-OUTPUT-STATEMENTS", "(DEFUN JAVA-OUTPUT-STATEMENTS ((STATEMENTLIST CONS)))", ((cpp_function_code)(&java_output_statements)), NULL);
    define_function_object("JAVA-OUTPUT-DECLARATIONS", "(DEFUN JAVA-OUTPUT-DECLARATIONS ((DECLARATIONS (CONS OF CONS))))", ((cpp_function_code)(&java_output_declarations)), NULL);
    define_function_object("JAVA-HEURISTICALLY-TRANSLATE-NAME", "(DEFUN (JAVA-HEURISTICALLY-TRANSLATE-NAME STRING) ((STELLA-NAME STRING) (CASE-CONVERTED-NAME-LIST (CONS OF STRING-WRAPPER))))", ((cpp_function_code)(&java_heuristically_translate_name)), NULL);
    define_function_object("JAVA-OUTPUT-COMMENT-STRING", "(DEFUN JAVA-OUTPUT-COMMENT-STRING ((COMMENT STRING) (COMMENT-START STRING) (COMMENT-CONTINUATION STRING) (COMMENT-END STRING) (JAVADOC-COMMENT? BOOLEAN) (CASE-CONVERTED-NAME-LIST (CONS OF STRING-WRAPPER))))", ((cpp_function_code)(&java_output_comment_string)), NULL);
    define_function_object("JAVA-OUTPUT-COMMENT", "(DEFUN JAVA-OUTPUT-COMMENT ((TREE STRING-WRAPPER)))", ((cpp_function_code)(&java_output_comment)), NULL);
    define_function_object("JAVA-OUTPUT-JAVADOC-COMMENT", "(DEFUN JAVA-OUTPUT-JAVADOC-COMMENT ((TREE STRING-WRAPPER) (PARAMETER-NAMES-AND-TYPES (CONS OF (CONS OF STRING-WRAPPER))) (RETURN-VALUE STRING-WRAPPER) (AUTHOR STRING) (VERSION STRING)))", ((cpp_function_code)(&java_output_javadoc_comment)), NULL);
    define_function_object("JAVA-OUTPUT-VERBATIM", "(DEFUN JAVA-OUTPUT-VERBATIM ((VERBATIMSTATEMENT STRING-WRAPPER)))", ((cpp_function_code)(&java_output_verbatim)), NULL);
    define_function_object("JAVA-OUTPUT-MAKE", "(DEFUN JAVA-OUTPUT-MAKE ((STATEMENT CONS)))", ((cpp_function_code)(&java_output_make)), NULL);
    define_function_object("JAVA-OUTPUT-CAST", "(DEFUN JAVA-OUTPUT-CAST ((TREE CONS)))", ((cpp_function_code)(&java_output_cast)), NULL);
    define_function_object("JAVA-OUTPUT-PROGN", "(DEFUN JAVA-OUTPUT-PROGN ((PROGN CONS)))", ((cpp_function_code)(&java_output_progn)), NULL);
    define_function_object("JAVA-OUTPUT-BLOCK", "(DEFUN JAVA-OUTPUT-BLOCK ((BLOCK CONS)))", ((cpp_function_code)(&java_output_block)), NULL);
    define_function_object("JAVA-OUTPUT-WITH-PROCESS-LOCK", "(DEFUN JAVA-OUTPUT-WITH-PROCESS-LOCK ((SYNCH CONS)))", ((cpp_function_code)(&java_output_with_process_lock)), NULL);
    define_function_object("JAVA-OUTPUT-RETURN", "(DEFUN JAVA-OUTPUT-RETURN ((RETURNSTATEMENT CONS)))", ((cpp_function_code)(&java_output_return)), NULL);
    define_function_object("JAVA-OUTPUT-THROW", "(DEFUN JAVA-OUTPUT-THROW ((TREE CONS)))", ((cpp_function_code)(&java_output_throw)), NULL);
    define_function_object("JAVA-OUTPUT-CATCH", "(DEFUN JAVA-OUTPUT-CATCH ((TREE CONS)))", ((cpp_function_code)(&java_output_catch)), NULL);
    define_function_object("JAVA-OUTPUT-UNWIND-PROTECT", "(DEFUN JAVA-OUTPUT-UNWIND-PROTECT ((TREE CONS)))", ((cpp_function_code)(&java_output_unwind_protect)), NULL);
    define_function_object("JAVA-OUTPUT-HANDLER-CASE", "(DEFUN JAVA-OUTPUT-HANDLER-CASE ((TREE CONS)))", ((cpp_function_code)(&java_output_handler_case)), NULL);
  }
}

void startup_java_output() {
  { 
    BIND_STELLA_SPECIAL(oMODULEo, Module*, oSTELLA_MODULEo);
    BIND_STELLA_SPECIAL(oCONTEXTo, Context*, oMODULEo.get());
    if (current_startup_time_phaseP(2)) {
      help_startup_java_output1();
      help_startup_java_output2();
    }
    if (current_startup_time_phaseP(4)) {
      oJAVA_STELLA_PACKAGE_MAPPINGo = new_key_value_list();
      oJAVA_SEMICOLON_STATEMENTSo = listO(22, SYM_JAVA_OUTPUT_STELLA_JAVA_ASSIGN, SYM_JAVA_OUTPUT_STELLA_JAVA_UNARY_OP, SYM_JAVA_OUTPUT_STELLA_JAVA_BINARY_OP, SYM_JAVA_OUTPUT_STELLA_JAVA_TERNARY_OP, SYM_JAVA_OUTPUT_STELLA_JAVA_CAST, SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCALL, SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCTION_CALL, SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCTION_POINTER, SYM_JAVA_OUTPUT_STELLA_JAVA_MAKE, SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_CALL, SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_CODE_CALL, SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_POINTER, SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_SETTER_CALL, SYM_JAVA_OUTPUT_STELLA_JAVA_NEW, SYM_JAVA_OUTPUT_STELLA_JAVA_PRINT_NATIVE_STREAM, SYM_JAVA_OUTPUT_STELLA_JAVA_PRINT_STREAM, SYM_JAVA_OUTPUT_STELLA_JAVA_RETURN, SYM_JAVA_OUTPUT_STELLA_JAVA_SIGNAL, SYM_JAVA_OUTPUT_STELLA_JAVA_SLOT_VALUE_SETTER, SYM_JAVA_OUTPUT_STELLA_JAVA_THROW, SYM_JAVA_OUTPUT_STELLA_JAVA_VERBATIM, NIL);
    }
    if (current_startup_time_phaseP(6)) {
      finalize_classes();
    }
    if (current_startup_time_phaseP(7)) {
      help_startup_java_output3();
      define_function_object("JAVA-OUTPUT-SIGNAL", "(DEFUN JAVA-OUTPUT-SIGNAL ((TREE CONS)))", ((cpp_function_code)(&java_output_signal)), NULL);
      define_function_object("JAVA-OUTPUT-GLOBAL-DEFINITION", "(DEFUN JAVA-OUTPUT-GLOBAL-DEFINITION ((GLOBAL CONS)))", ((cpp_function_code)(&java_output_global_definition)), NULL);
      define_function_object("JAVA-OUTPUT-SPECIAL-DEFINITION", "(DEFUN JAVA-OUTPUT-SPECIAL-DEFINITION ((SPECIAL CONS)))", ((cpp_function_code)(&java_output_special_definition)), NULL);
      define_function_object("JAVA-OUTPUT-ACTUALS-AS-CONS-EXPRESSION", "(DEFUN JAVA-OUTPUT-ACTUALS-AS-CONS-EXPRESSION ((ARGLIST CONS)))", ((cpp_function_code)(&java_output_actuals_as_cons_expression)), NULL);
      define_function_object("JAVA-OUTPUT-FUNCALL", "(DEFUN JAVA-OUTPUT-FUNCALL ((FUNCALL CONS)))", ((cpp_function_code)(&java_output_funcall)), NULL);
      define_function_object("JAVA-OUTPUT-METHOD-CODE-CALL", "(DEFUN JAVA-OUTPUT-METHOD-CODE-CALL ((METHODCALL CONS)))", ((cpp_function_code)(&java_output_method_code_call)), NULL);
      define_function_object("JAVA-OUTPUT-BREAK", "(DEFUN JAVA-OUTPUT-BREAK ((TAG CONS)))", ((cpp_function_code)(&java_output_break)), NULL);
      define_function_object("JAVA-OUTPUT-CONTINUE", "(DEFUN JAVA-OUTPUT-CONTINUE ((TAG CONS)))", ((cpp_function_code)(&java_output_continue)), NULL);
      define_function_object("JAVA-STATEMENT-RETURNS?", "(DEFUN (JAVA-STATEMENT-RETURNS? BOOLEAN) ((STATEMENT CONS)))", ((cpp_function_code)(&java_statement_returnsP)), NULL);
      define_function_object("JAVA-LAST-STATEMENT-RETURNS?", "(DEFUN (JAVA-LAST-STATEMENT-RETURNS? BOOLEAN) ((STATEMENTS CONS)))", ((cpp_function_code)(&java_last_statement_returnsP)), NULL);
      define_function_object("JAVA-OUTPUT-CASE", "(DEFUN JAVA-OUTPUT-CASE ((CASE CONS)))", ((cpp_function_code)(&java_output_case)), NULL);
      define_function_object("JAVA-OUTPUT-COND", "(DEFUN JAVA-OUTPUT-COND ((COND CONS)))", ((cpp_function_code)(&java_output_cond)), NULL);
      define_function_object("JAVA-PROGN?", "(DEFUN (JAVA-PROGN? BOOLEAN) ((TREE OBJECT)))", ((cpp_function_code)(&java_prognP)), NULL);
      define_function_object("JAVA-BLOCK?", "(DEFUN (JAVA-BLOCK? BOOLEAN) ((TREE OBJECT)))", ((cpp_function_code)(&java_blockP)), NULL);
      define_function_object("JAVA-OUTPUT-IF", "(DEFUN JAVA-OUTPUT-IF ((TREE CONS)))", ((cpp_function_code)(&java_output_if)), NULL);
      define_function_object("JAVA-OUTPUT-WHEN", "(DEFUN JAVA-OUTPUT-WHEN ((TREE CONS)))", ((cpp_function_code)(&java_output_when)), NULL);
      define_function_object("JAVA-OUTPUT-UNLESS", "(DEFUN JAVA-OUTPUT-UNLESS ((TREE CONS)))", ((cpp_function_code)(&java_output_unless)), NULL);
      define_function_object("JAVA-OUTPUT-ASSIGNMENT", "(DEFUN JAVA-OUTPUT-ASSIGNMENT ((ASSIGNMENT CONS)))", ((cpp_function_code)(&java_output_assignment)), NULL);
      define_function_object("JAVA-OUTPUT-LOOP", "(DEFUN JAVA-OUTPUT-LOOP ((LOOP CONS)))", ((cpp_function_code)(&java_output_loop)), NULL);
      define_function_object("JAVA-OUTPUT-WHILE", "(DEFUN JAVA-OUTPUT-WHILE ((LOOP CONS)))", ((cpp_function_code)(&java_output_while)), NULL);
      define_function_object("JAVA-OUTPUT-FOREACH", "(DEFUN JAVA-OUTPUT-FOREACH ((LOOP CONS)))", ((cpp_function_code)(&java_output_foreach)), NULL);
      define_function_object("JAVA-END-OF-LINE-TOKEN?", "(DEFUN (JAVA-END-OF-LINE-TOKEN? BOOLEAN) ((TOKEN OBJECT)))", ((cpp_function_code)(&java_end_of_line_tokenP)), NULL);
      define_function_object("JAVA-OUTPUT-PRINT-STREAM", "(DEFUN JAVA-OUTPUT-PRINT-STREAM ((EXPS CONS) (NATIVESTREAM? BOOLEAN)))", ((cpp_function_code)(&java_output_print_stream)), NULL);
      define_function_object("JAVA-HELP-OUTPUT-PRINT-STREAM", "(DEFUN JAVA-HELP-OUTPUT-PRINT-STREAM ((STREAM OBJECT) (EXPS CONS) (NATIVESTREAM? BOOLEAN) (ENDOFLINE? BOOLEAN)))", ((cpp_function_code)(&java_help_output_print_stream)), NULL);
      define_function_object("JAVA-INDENTABLE-BINARY-OPERATOR?", "(DEFUN (JAVA-INDENTABLE-BINARY-OPERATOR? BOOLEAN) ((OPERATOR STRING-WRAPPER)))", ((cpp_function_code)(&java_indentable_binary_operatorP)), NULL);
      define_function_object("JAVA-COMMUTATIVE-BINARY-OPERATOR?", "(DEFUN (JAVA-COMMUTATIVE-BINARY-OPERATOR? BOOLEAN) ((OPERATOR STRING-WRAPPER)))", ((cpp_function_code)(&java_commutative_binary_operatorP)), NULL);
      define_function_object("JAVA-BINARY-OPERATOR?", "(DEFUN (JAVA-BINARY-OPERATOR? BOOLEAN) ((STATEMENT OBJECT)))", ((cpp_function_code)(&java_binary_operatorP)), NULL);
      define_function_object("JAVA-OPERATOR?", "(DEFUN (JAVA-OPERATOR? BOOLEAN) ((STATEMENT OBJECT)))", ((cpp_function_code)(&java_operatorP)), NULL);
      define_function_object("JAVA-OUTPUT-UNARY-OPERATOR", "(DEFUN JAVA-OUTPUT-UNARY-OPERATOR ((EXPRESSION CONS)))", ((cpp_function_code)(&java_output_unary_operator)), NULL);
      define_function_object("JAVA-NESTED-OPERATOR-NEEDS-PARENTHESES?", "(DEFUN (JAVA-NESTED-OPERATOR-NEEDS-PARENTHESES? BOOLEAN) ((OP STRING-WRAPPER) (NESTED OBJECT)))", ((cpp_function_code)(&java_nested_operator_needs_parenthesesP)), NULL);
      define_function_object("JAVA-HELP-OUTPUT-BINARY-OPERATOR", "(DEFUN JAVA-HELP-OUTPUT-BINARY-OPERATOR ((EXPRESSION CONS) (NESTLEVEL INTEGER)))", ((cpp_function_code)(&java_help_output_binary_operator)), NULL);
      define_function_object("JAVA-OUTPUT-BINARY-OPERATOR", "(DEFUN JAVA-OUTPUT-BINARY-OPERATOR ((EXPRESSION CONS)))", ((cpp_function_code)(&java_output_binary_operator)), NULL);
      define_function_object("JAVA-OUTPUT-TERNARY-OPERATOR", "(DEFUN JAVA-OUTPUT-TERNARY-OPERATOR ((EXPRESSION CONS)))", ((cpp_function_code)(&java_output_ternary_operator)), NULL);
      define_function_object("JAVA-OUTPUT-METHOD-CALL", "(DEFUN JAVA-OUTPUT-METHOD-CALL ((METHODCALL CONS)))", ((cpp_function_code)(&java_output_method_call)), NULL);
      define_function_object("JAVA-OUTPUT-FUNCTION-CALL", "(DEFUN JAVA-OUTPUT-FUNCTION-CALL ((FUNCTIONCALL CONS)))", ((cpp_function_code)(&java_output_function_call)), NULL);
      define_function_object("JAVA-OUTPUT-ACTUAL-PARAMETERS", "(DEFUN JAVA-OUTPUT-ACTUAL-PARAMETERS ((PARAMETERS CONS)))", ((cpp_function_code)(&java_output_actual_parameters)), NULL);
      define_function_object("STARTUP-JAVA-OUTPUT", "(DEFUN STARTUP-JAVA-OUTPUT () :PUBLIC? TRUE)", ((cpp_function_code)(&startup_java_output)), NULL);
      { Method_Slot* function = lookup_function(SYM_JAVA_OUTPUT_STELLA_STARTUP_JAVA_OUTPUT);

        set_dynamic_slot_value(function->dynamic_slots, SYM_JAVA_OUTPUT_STELLA_METHOD_STARTUP_CLASSNAME, wrap_string("Startup-Java-Output"), NULL_STRING_WRAPPER);
      }
    }
    if (current_startup_time_phaseP(8)) {
      finalize_slots();
      cleanup_unfinalized_classes();
    }
    if (current_startup_time_phaseP(9)) {
      define_stella_global_variable_from_stringified_source("(DEFSPECIAL *JAVA-INDENT-CHARS* INTEGER 0)");
      define_stella_global_variable_from_stringified_source("(DEFGLOBAL *JAVA-STELLA-PACKAGE-MAPPING* (KEY-VALUE-LIST OF STRING-WRAPPER STRING-WRAPPER) (NEW (KEY-VALUE-LIST OF STRING-WRAPPER STRING-WRAPPER)))");
      define_stella_global_variable_from_stringified_source("(DEFGLOBAL *JAVA-SEMICOLON-STATEMENTS* (CONS OF SYMBOL) (BQUOTE (JAVA_ASSIGN JAVA_UNARY_OP JAVA_BINARY_OP JAVA_TERNARY_OP JAVA_CAST JAVA_FUNCALL JAVA_FUNCTION_CALL JAVA_FUNCTION_POINTER JAVA_MAKE JAVA_METHOD_CALL JAVA_METHOD_CODE_CALL JAVA_METHOD_POINTER JAVA_METHOD_SETTER_CALL JAVA_NEW JAVA_PRINT_NATIVE_STREAM JAVA_PRINT_STREAM JAVA_RETURN JAVA_SIGNAL JAVA_SLOT_VALUE_SETTER JAVA_THROW JAVA_VERBATIM)))");
    }
  }
}

Surrogate* SGT_JAVA_OUTPUT_STELLA_CONS = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_CLASS = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_EXCEPTION_CLASS = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_NAMED_STATEMENT = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_STATEMENTS = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_IDENT = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_EOL = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_LITERAL = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_COMMENT = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_SYMBOL = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_CATCH = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_THROW = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_UNWIND_PROTECT = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_HANDLER_CASE = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_SIGNAL = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_VERBATIM = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_CAST = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_GLOBAL = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_SPECIAL = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_TYPE = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_PROGN = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_BLOCK = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_WITH_PROCESS_LOCK = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_RETURN = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_MAKE = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCALL = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_CODE_CALL = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_ASSIGN = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_BREAK = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_CONTINUE = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_COND = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_CASE = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_IF = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_WHEN = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_UNLESS = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_LOOP = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_WHILE = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_FOREACH = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_SLOT_VALUE = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_SLOT_VALUE_SETTER = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_UNARY_OP = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_BINARY_OP = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_TERNARY_OP = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCTION_CALL = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_CALL = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_ACTUALS = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_MAKE_ARRAY = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_ARRAY_INITIALIZER = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_ANONYMOUS_ARRAY = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_AREF = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCTION = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_PRINT_STREAM = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_PRINT_NATIVE_STREAM = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_DECLARATIONS = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCTION_POINTER = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_POINTER = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_SETTER_CALL = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_NEW = NULL;

Keyword* KWD_JAVA_OUTPUT_NO = NULL;

Keyword* KWD_JAVA_OUTPUT_PRESERVE = NULL;

Keyword* KWD_JAVA_OUTPUT_CLEVER = NULL;

Keyword* KWD_JAVA_OUTPUT_UPCASE = NULL;

Keyword* KWD_JAVA_OUTPUT_TITLECASEX = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_STANDARD_OUT = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_STANDARD_ERROR = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_STARTUP_JAVA_OUTPUT = NULL;

Symbol* SYM_JAVA_OUTPUT_STELLA_METHOD_STARTUP_CLASSNAME = NULL;

} // end of namespace stella
