// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/literals.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/



namespace stella {

// Global declarations:
extern Integer_Wrapper* ZERO_WRAPPER;
extern Integer_Wrapper* ONE_WRAPPER;
extern Boolean_Wrapper* TRUE_WRAPPER;
extern Boolean_Wrapper* FALSE_WRAPPER;
extern Integer_Wrapper* NULL_INTEGER_WRAPPER;
extern Float_Wrapper* NULL_FLOAT_WRAPPER;
extern String_Wrapper* NULL_STRING_WRAPPER;
extern Mutable_String_Wrapper* NULL_MUTABLE_STRING_WRAPPER;
extern Character_Wrapper* NULL_CHARACTER_WRAPPER;
extern Function_Code_Wrapper* NULL_FUNCTION_CODE_WRAPPER;
extern Method_Code_Wrapper* NULL_METHOD_CODE_WRAPPER;
extern Hash_Table* oLITERAL_TYPE_INFO_TABLEo;
extern List* oLITERAL_TYPESo;
extern Keyword** oCHARACTER_TYPE_TABLEo;
extern char* oCHARACTER_UPCASE_TABLEo;
extern char* oCHARACTER_DOWNCASE_TABLEo;

// Function signatures:
Object* lookup_literal_type_info(Surrogate* type, Keyword* key);
void set_literal_type_info(Surrogate* type, Keyword* key, Object* value);
Integer_Wrapper* wrap_integer(int value);
int unwrap_integer(Integer_Wrapper* wrapper);
Float_Wrapper* wrap_float(double value);
double unwrap_float(Float_Wrapper* wrapper);
String_Wrapper* wrap_string(char* value);
char* unwrap_string(String_Wrapper* wrapper);
Mutable_String_Wrapper* wrap_mutable_string(char* value);
char* unwrap_mutable_string(Mutable_String_Wrapper* wrapper);
Character_Wrapper* wrap_character(char value);
char unwrap_character(Character_Wrapper* wrapper);
Function_Code_Wrapper* wrap_function_code(cpp_function_code value);
cpp_function_code unwrap_function_code(Function_Code_Wrapper* wrapper);
Method_Code_Wrapper* wrap_method_code(cpp_method_code value);
cpp_method_code unwrap_method_code(Method_Code_Wrapper* wrapper);
Boolean_Wrapper* wrap_boolean(boolean value);
boolean unwrap_boolean(Boolean_Wrapper* wrapper);
boolean coerce_wrapped_boolean_to_boolean(Boolean_Wrapper* wrapper);
Object* inline_wrap_boolean_expander(Object* expression);
Object* inline_unwrap_boolean_expander(Object* expression);
Integer_Wrapper* integer_wrap_literal(int value);
Float_Wrapper* float_wrap_literal(double value);
Mutable_String_Wrapper* mutable_string_wrap_literal(char* value);
String_Wrapper* string_wrap_literal(char* value);
Character_Wrapper* character_wrap_literal(char value);
Function_Code_Wrapper* function_code_wrap_literal(cpp_function_code value);
Method_Code_Wrapper* method_code_wrap_literal(cpp_method_code value);
boolean eql_to_booleanP(Object* y, boolean x);
boolean eql_to_integerP(Object* y, int x);
boolean eql_to_floatP(Object* y, double x);
boolean eql_to_stringP(Object* y, char* x);
boolean eql_to_characterP(Object* y, char x);
Object* help_bquotify(Object* tree);
Object* bquotify(Object* tree);
Object* expand_bquote_tree(Object* tree);
Object* simplify_bquote_tree(Object* tree);
Object* permanent_copy(Object* tree);
void print_character(char renamed_Char, ostream* stream);
Keyword** create_character_type_table();
boolean digit_characterP(char ch);
boolean letter_characterP(char ch);
boolean upper_case_characterP(char ch);
boolean lower_case_characterP(char ch);
boolean white_space_characterP(char ch);
boolean all_upper_case_stringP(char* s);
boolean all_lower_case_stringP(char* s);
char* initialize_character_upcase_table();
char* initialize_character_downcase_table();
char upcase_character(char renamed_Char);
char downcase_character(char renamed_Char);
void print_string_readably(char* string, ostream* stream);
char* string_to_mutable_string(char* s);
char* mutable_string_to_string(char* s);
void help_startup_literals1();
void help_startup_literals2();
void help_startup_literals3();
void startup_literals();

// Auxiliary global declarations:
extern Surrogate* SGT_LITERALS_STELLA_BOOLEAN;
extern Keyword* KWD_LITERALS_NULL_WRAPPER;
extern Symbol* SYM_LITERALS_STELLA_FALSE_WRAPPER;
extern Surrogate* SGT_LITERALS_STELLA_INTEGER;
extern Symbol* SYM_LITERALS_STELLA_NULL_INTEGER_WRAPPER;
extern Surrogate* SGT_LITERALS_STELLA_FLOAT;
extern Symbol* SYM_LITERALS_STELLA_NULL_FLOAT_WRAPPER;
extern Surrogate* SGT_LITERALS_STELLA_STRING;
extern Symbol* SYM_LITERALS_STELLA_NULL_STRING_WRAPPER;
extern Surrogate* SGT_LITERALS_STELLA_MUTABLE_STRING;
extern Symbol* SYM_LITERALS_STELLA_NULL_MUTABLE_STRING_WRAPPER;
extern Surrogate* SGT_LITERALS_STELLA_CHARACTER;
extern Symbol* SYM_LITERALS_STELLA_NULL_CHARACTER_WRAPPER;
extern Surrogate* SGT_LITERALS_STELLA_FUNCTION_CODE;
extern Symbol* SYM_LITERALS_STELLA_NULL_FUNCTION_CODE_WRAPPER;
extern Surrogate* SGT_LITERALS_STELLA_METHOD_CODE;
extern Symbol* SYM_LITERALS_STELLA_NULL_METHOD_CODE_WRAPPER;
extern Symbol* SYM_LITERALS_STELLA_TRUE;
extern Symbol* SYM_LITERALS_STELLA_TRUE_WRAPPER;
extern Symbol* SYM_LITERALS_STELLA_FALSE;
extern Symbol* SYM_LITERALS_STELLA_WRAP_BOOLEAN;
extern Symbol* SYM_LITERALS_STELLA_INLINE_WRAP_BOOLEAN;
extern Symbol* SYM_LITERALS_STELLA_INLINE_WRAP_BOOLEAN_EXPANDER;
extern Symbol* SYM_LITERALS_STELLA_COERCE_WRAPPED_BOOLEAN_TO_BOOLEAN;
extern Symbol* SYM_LITERALS_STELLA_INLINE_UNWRAP_BOOLEAN;
extern Symbol* SYM_LITERALS_STELLA_INLINE_UNWRAP_BOOLEAN_EXPANDER;
extern Keyword* KWD_LITERALS_WRAP_FUNCTION;
extern Symbol* SYM_LITERALS_STELLA_WRAP_INTEGER;
extern Symbol* SYM_LITERALS_STELLA_WRAP_FLOAT;
extern Symbol* SYM_LITERALS_STELLA_WRAP_STRING;
extern Symbol* SYM_LITERALS_STELLA_WRAP_CHARACTER;
extern Symbol* SYM_LITERALS_STELLA_WRAP_FUNCTION_CODE;
extern Symbol* SYM_LITERALS_STELLA_WRAP_METHOD_CODE;
extern Surrogate* SGT_LITERALS_STELLA_INTEGER_WRAPPER;
extern Surrogate* SGT_LITERALS_STELLA_FLOAT_WRAPPER;
extern Surrogate* SGT_LITERALS_STELLA_STRING_WRAPPER;
extern Surrogate* SGT_LITERALS_STELLA_VERBATIM_STRING_WRAPPER;
extern Surrogate* SGT_LITERALS_STELLA_CHARACTER_WRAPPER;
extern Symbol* SYM_LITERALS_STELLA_NULL;
extern Surrogate* SGT_LITERALS_STELLA_CONS;
extern Symbol* SYM_LITERALS_STELLA_NIL;
extern Symbol* SYM_LITERALS_STELLA_CONS;
extern Symbol* SYM_LITERALS_STELLA_WRAP_LITERAL;
extern Symbol* SYM_LITERALS_STELLA_GET_KWD;
extern Symbol* SYM_LITERALS_STELLA_TYPED_SYS;
extern Surrogate* SGT_LITERALS_STELLA_SYMBOL;
extern Symbol* SYM_LITERALS_STELLA_GET_SGT;
extern Symbol* SYM_LITERALS_STELLA_INTERN_COMMON_LISP_SYMBOL;
extern Symbol* SYM_LITERALS_STELLA_GET_SYM;
extern Symbol* SYM_LITERALS_STELLA_LISTo;
extern Symbol* SYM_LITERALS_STELLA_a;
extern Symbol* SYM_LITERALS_STELLA_aa;
extern Symbol* SYM_LITERALS_STELLA_CONCATENATE;
extern Keyword* KWD_LITERALS_OTHER;
extern Keyword* KWD_LITERALS_DIGIT;
extern Keyword* KWD_LITERALS_LETTER;
extern Keyword* KWD_LITERALS_SYMBOL_CONSTITUENT;
extern Keyword* KWD_LITERALS_SYMBOL_QUALIFIER;
extern Keyword* KWD_LITERALS_ESCAPE;
extern Keyword* KWD_LITERALS_DELIMITER;
extern Keyword* KWD_LITERALS_WHITE_SPACE;
extern Symbol* SYM_LITERALS_STELLA_STARTUP_LITERALS;
extern Symbol* SYM_LITERALS_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
