// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/methods.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/



namespace stella {

// Global declarations:
extern int oMAXIMUM_STRING_CONSTANT_SIZEo;
extern Hash_Table* oFUNCTION_LOOKUP_TABLEo;
extern Hash_Table* oGLOBAL_VARIABLE_LOOKUP_TABLEo;

// Function signatures:
Object* apply(cpp_function_code code, Cons* arguments);
Object* apply_method(cpp_method_code code, Cons* arguments);
int apply_integer_method(cpp_method_code code, Cons* arguments);
char* apply_string_method(cpp_method_code code, Cons* arguments);
boolean apply_boolean_method(cpp_method_code code, Cons* arguments);
double apply_float_method(cpp_method_code code, Cons* arguments);
boolean defined_typeP(Surrogate* type);
Standard_Object* real_type_specifier(Surrogate* type);
Surrogate* canonical_type(Surrogate* type);
Parametric_Type_Specifier* yield_parametric_type_specifier(Cons* typespectree);
List* parse_array_dimensions_spec(Object* dimensionsspec);
Cons* yield_array_dimensions_tree(Parametric_Type_Specifier* arraytype);
boolean array_type_specifierP(Standard_Object* typespec);
int array_type_rank(Parametric_Type_Specifier* arraytype);
List* array_type_dimensions(Parametric_Type_Specifier* arraytype);
boolean indefinite_array_typeP(Parametric_Type_Specifier* arraytype);
Anchored_Type_Specifier* yield_anchored_type_specifier(Cons* typespectree);
void incorporate_input_parameters(Method_Slot* method, Cons* parameters);
void incorporate_first_input_parameter(Method_Slot* method);
Method_Slot* define_stella_method_slot(Symbol* inputname, Cons* returntypes, boolean functionP, Cons* inputparameters, Keyword_Key_Value_List* options);
Method_Slot* attach_method_slot_to_owner(Method_Slot* newmethod);
Object* yield_string_constant_tree(char* string);
Cons* yield_define_stella_method_object(Method_Slot* method, Method_Slot* codemethod, Method_Slot* wrappermethod);
Cons* yield_class_parameter_types(Class* renamed_Class);
boolean optimistic_subtype_ofP(Surrogate* subtype, Surrogate* supertype);
void warn_of_parameter_mismatch(Parametric_Type_Specifier* self, char* message);
Surrogate* validate_type_specifier(Standard_Object* self, Class* anchorclass, boolean skipanchoredtypeP);
Cons* synthesize_method_body(Method_Slot* method);
void undefine_external_slots(Symbol* name);
void destroy_external_slot(Slot* self);
void destroy_method(Method_Slot* self);
Surrogate* type_spec_to_base_type(Standard_Object* self);
Standard_Object* base_type_to_type_spec(Standard_Object* self);
Class* type_spec_to_class(Standard_Object* self);
boolean compatible_parameter_typesP(Standard_Object* subtype, Standard_Object* supertype);
boolean sub_type_spec_ofP(Standard_Object* subtype, Standard_Object* supertype);
boolean voidP(Standard_Object* type);
Standard_Object* extract_parameter_type(Standard_Object* self, Symbol* parameter, boolean& _return1);
Standard_Object* compute_anchored_type_spec(Standard_Object* ownertype, Anchored_Type_Specifier* reltype);
Standard_Object* compute_relative_type_spec(Standard_Object* relativetype, Standard_Object* ownertype);
Object* yield_type_spec_tree(Standard_Object* self);
Method_Slot* attach_function(Method_Slot* newfunction);
Method_Slot* lookup_function(Symbol* functionsymbol);
Method_Slot* lookup_function_by_name(char* name);
Method_Slot* lookup_function_or_stella_function(Symbol* functionsymbol);
void undefine_function(Symbol* name);
void destroy_function(Method_Slot* function);
boolean undefine_conflicting_definitionsP(Method_Slot* newslot);
void define_function_object(char* name, char* definition, cpp_function_code code, cpp_function_code wrappercode);
Global_Variable* intern_global_variable(Global_Variable* global);
Global_Variable* string_lookup_global_variable(char* self);
Standard_Object* global_variable_type_spec(Global_Variable* global);
Standard_Object* lookup_global_variable_type(Symbol* name);
Global_Variable* define_stella_global_variable_from_parse_tree(Cons* tree, char* stringifiedsource, Object*& _return1);
void define_stella_global_variable_from_stringified_source(char* stringifiedsource);
Module* record_variable_home_module(Global_Variable* self);
Object* get_global_value(Surrogate* self);
Object* set_global_value(Surrogate* self, Object* value);
void destroy_variable(Global_Variable* variable);
Surrogate* define_stella_type_from_parse_tree(Cons* tree);
void define_stella_type_from_stringified_source(char* stringifiedsource);
void help_startup_methods1();
void help_startup_methods2();
void help_startup_methods3();
void startup_methods();

// Auxiliary global declarations:
extern Surrogate* SGT_METHODS_STELLA_SURROGATE;
extern Surrogate* SGT_METHODS_STELLA_PARAMETRIC_TYPE_SPECIFIER;
extern Surrogate* SGT_METHODS_STELLA_ANCHORED_TYPE_SPECIFIER;
extern Surrogate* SGT_METHODS_STELLA_OBJECT;
extern Surrogate* SGT_METHODS_STELLA_VOID;
extern Symbol* SYM_METHODS_STELLA_LIKE;
extern Symbol* SYM_METHODS_STELLA_SIZE;
extern Symbol* SYM_METHODS_STELLA_UNKNOWN;
extern Symbol* SYM_METHODS_STELLA_OF;
extern Symbol* SYM_METHODS_STELLA_NULL;
extern Surrogate* SGT_METHODS_STELLA_ARRAY;
extern Symbol* SYM_METHODS_STELLA_SELF;
extern Surrogate* SGT_METHODS_STELLA_CONS;
extern Symbol* SYM_METHODS_STELLA_IN;
extern Symbol* SYM_METHODS_STELLA_OUT;
extern Symbol* SYM_METHODS_STELLA_INOUT;
extern Symbol* SYM_METHODS_STELLA_METHOD_PARAMETER_DIRECTIONS;
extern Symbol* SYM_METHODS_STELLA_ARGUMENT_LIST;
extern Symbol* SYM_METHODS_STELLA_aREST;
extern Symbol* SYM_METHODS_STELLA_METHOD_VARIABLE_ARGUMENTSp;
extern Symbol* SYM_METHODS_STELLA_aBODY;
extern Symbol* SYM_METHODS_STELLA_METHOD_BODY_ARGUMENTp;
extern Surrogate* SGT_METHODS_STELLA_UNKNOWN;
extern Keyword* KWD_METHODS_TYPE;
extern Keyword* KWD_METHODS_RETURN_TYPES;
extern Symbol* SYM_METHODS_STELLA_SLOT_TYPE_SPECIFIER;
extern Keyword* KWD_METHODS_PUBLICp;
extern Keyword* KWD_METHODS_ABSTRACTp;
extern Keyword* KWD_METHODS_NATIVEp;
extern Symbol* SYM_METHODS_STELLA_METHOD_NATIVEp;
extern Keyword* KWD_METHODS_CONSTRUCTORp;
extern Symbol* SYM_METHODS_STELLA_METHOD_CONSTRUCTORp;
extern Keyword* KWD_METHODS_GLOBALLY_INLINEp;
extern Symbol* SYM_METHODS_STELLA_METHOD_GLOBALLY_INLINEp;
extern Keyword* KWD_METHODS_INLINE;
extern Symbol* SYM_METHODS_STELLA_METHOD_INLINED_FUNCTIONS;
extern Keyword* KWD_METHODS_AUXILIARYp;
extern Symbol* SYM_METHODS_STELLA_SLOT_AUXILIARYp;
extern Keyword* KWD_METHODS_DOCUMENTATION;
extern Symbol* SYM_METHODS_STELLA_DOCUMENTATION;
extern Keyword* KWD_METHODS_RETURNS;
extern Keyword* KWD_METHODS_STORAGE_SLOT;
extern Symbol* SYM_METHODS_STELLA_STORAGE_SLOT;
extern Keyword* KWD_METHODS_INHERITS_THROUGH;
extern Symbol* SYM_METHODS_STELLA_METHOD_INHERITS_THROUGH;
extern Keyword* KWD_METHODS_PROPERTIES;
extern Symbol* SYM_METHODS_STELLA_PROPERTIES;
extern Keyword* KWD_METHODS_META_ATTRIBUTES;
extern Symbol* SYM_METHODS_STELLA_META_ATTRIBUTES;
extern Keyword* KWD_METHODS_COMMANDp;
extern Symbol* SYM_METHODS_STELLA_METHOD_COMMANDp;
extern Keyword* KWD_METHODS_LISP_MACROp;
extern Symbol* SYM_METHODS_STELLA_METHOD_LISP_MACROp;
extern Keyword* KWD_METHODS_EVALUATE_ARGUMENTSp;
extern Symbol* SYM_METHODS_STELLA_METHOD_EVALUATE_ARGUMENTSp;
extern Symbol* SYM_METHODS_STELLA_CONCATENATE;
extern Symbol* SYM_METHODS_STELLA_DEFINE_FUNCTION_OBJECT;
extern Symbol* SYM_METHODS_STELLA_THE_CODE;
extern Keyword* KWD_METHODS_FUNCTION;
extern Symbol* SYM_METHODS_STELLA_DEFINE_METHOD_OBJECT;
extern Keyword* KWD_METHODS_METHOD;
extern Surrogate* SGT_METHODS_STELLA_BOOLEAN;
extern Symbol* SYM_METHODS_STELLA_SUPER_CLASSES;
extern Symbol* SYM_METHODS_STELLA_EQUIVALENT_SLOT;
extern Symbol* SYM_METHODS_STELLA_CLASS_ALL_SUPER_CLASSES;
extern Symbol* SYM_METHODS_STELLA_SLOT_DIRECT_EQUIVALENT;
extern Symbol* SYM_METHODS_STELLA_LET;
extern Symbol* SYM_METHODS_STELLA_CURSOR;
extern Symbol* SYM_METHODS_STELLA_VALUE;
extern Symbol* SYM_METHODS_STELLA_SLOT_VALUE;
extern Symbol* SYM_METHODS_STELLA_LOOP;
extern Symbol* SYM_METHODS_STELLA_WHEN;
extern Symbol* SYM_METHODS_STELLA_RETURN;
extern Symbol* SYM_METHODS_STELLA_SETQ;
extern Symbol* SYM_METHODS_STELLA_IF;
extern Symbol* SYM_METHODS_STELLA_DEFINEDp;
extern Surrogate* SGT_METHODS_STELLA_COLLECTION;
extern Symbol* SYM_METHODS_STELLA_FIRST;
extern Symbol* SYM_METHODS_STELLA_VARIABLE_ARITY_TABLEp;
extern Surrogate* SGT_METHODS_STELLA_VECTOR;
extern Symbol* SYM_METHODS_STELLA_EVALUATOR_WRAPPER_CODE;
extern Symbol* SYM_METHODS_STELLA_VARIABLE_TYPE_SPECIFIER;
extern Symbol* SYM_METHODS_STELLA_DEFSPECIAL;
extern Symbol* SYM_METHODS_STELLA_DEFCONSTANT;
extern Keyword* KWD_METHODS_UNBOUND_SPECIAL_VARIABLE;
extern Symbol* SYM_METHODS_STELLA_VARIABLE_HOME_MODULE;
extern Symbol* SYM_METHODS_STELLA_STARTUP_METHODS;
extern Symbol* SYM_METHODS_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
