// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/more-demons.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/




namespace stella {

// Function signatures:
void inverse_slot_demon(Standard_Object* self, Storage_Slot* slot, Standard_Object* oldvalue, Standard_Object* newvalue);
void attach_inverse_slot_demon(Slot* slot);
void class_extension_constructor_demon(Active_Object* self, Class* renamed_Class);
void class_extension_destructor_demon(Active_Object* self, Class* renamed_Class);
void startup_more_demons();

// Auxiliary global declarations:
extern Symbol* SYM_MORE_DEMONS_STELLA_INVERSE;
extern Keyword* KWD_MORE_DEMONS_CODE;
extern Symbol* SYM_MORE_DEMONS_STELLA_SLOT_DEMONS;
extern Keyword* KWD_MORE_DEMONS_DOCUMENTATION;
extern Keyword* KWD_MORE_DEMONS_CREATE;
extern Keyword* KWD_MORE_DEMONS_ALL;
extern Keyword* KWD_MORE_DEMONS_DESTROY;
extern Symbol* SYM_MORE_DEMONS_STELLA_STARTUP_MORE_DEMONS;
extern Symbol* SYM_MORE_DEMONS_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
