// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/symbols.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/



namespace stella {

// Global declarations:
extern Extensible_Symbol_Array* oSYMBOL_ARRAYo;
extern Extensible_Symbol_Array* oSURROGATE_ARRAYo;
extern Extensible_Symbol_Array* oKEYWORD_ARRAYo;
extern String_To_Integer_Hash_Table* oKEYWORD_OFFSET_TABLEo;
extern Extensible_Symbol_Array* oFIXED_SYMBOL_ARRAYo;
extern Extensible_Symbol_Array* oFIXED_SURROGATE_ARRAYo;
extern Extensible_Symbol_Array* oFIXED_KEYWORD_ARRAYo;
extern String_Hash_Table* oTRANSIENT_SYMBOL_LOOKUP_TABLEo;
extern String_Hash_Table* oCOMMON_LISP_SYMBOL_LOOKUP_TABLEo;
extern int SYMBOL_SYM;
extern int SURROGATE_SYM;
extern int KEYWORD_SYM;
extern Module* oROOT_MODULEo;
extern Module* oSTELLA_MODULEo;
extern Module* oCOMMON_LISP_MODULEo;
extern Module* oALTERNATE_STELLA_MODULEo;
extern DECLARE_STELLA_SPECIAL(oCONTEXTo, Context* );
extern DECLARE_STELLA_SPECIAL(oMODULEo, Module* );
extern char SURROGATE_PREFIX_CHARACTER;
extern char MODULE_SEPARATOR_CHARACTER;
extern char* MODULE_SEPARATOR_STRING;
extern int oCONTEXT_NUMBER_COUNTERo;
extern int oGENSYM_COUNTERo;
extern char* oGENSYM_MASKo;
extern char* oSYMBOL_ESCAPE_CODE_TABLEo;
extern char* oCASE_SENSITIVE_SYMBOL_ESCAPE_CODE_TABLEo;

// Function signatures:
int next_free_offset(Extensible_Symbol_Array* self);
void free_symbol_offset(Extensible_Symbol_Array* self, int offset);
void add_to_symbol_array_at(Extensible_Symbol_Array* array, int offset, Generalized_Symbol* symbol);
int add_to_symbol_array(Extensible_Symbol_Array* array, Generalized_Symbol* symbol);
boolean legal_symbol_array_offsetP(Extensible_Symbol_Array* array, int offset);
Symbol* get_sym(int offset);
Surrogate* get_sgt(int offset);
Keyword* get_kwd(int offset);
Generalized_Symbol* get_generalized_symbol_from_offset(Extensible_Symbol_Array* symbolarray, int offset);
Symbol* get_sym_from_offset(int offset);
Surrogate* get_sgt_from_offset(int offset);
Keyword* get_kwd_from_offset(int offset);
String_To_Integer_Hash_Table* select_symbol_offset_table(Module* module, int kindofsym);
Extensible_Symbol_Array* select_symbol_array(int kindofsym);
Generalized_Symbol* lookup_rigid_symbol_locally(char* name, Module* module, int kindofsym);
Cons* yield_visible_rigid_symbols_wrt_module(char* name, Module* module, int kindofsym);
Iterator* visible_rigid_symbols_wrt_module(char* name, Module* module, int kindofsym);
Cons* remove_shadowed_symbols(Cons* visiblesymbols);
int lookup_rigid_symbol_offset_wrt_module(char* name, Module* module, int kindofsym);
Generalized_Symbol* lookup_rigid_symbol_wrt_module(char* name, Module* module, int kindofsym);
Generalized_Symbol* lookup_rigid_symbol(char* name, int kindofsym);
Symbol* lookup_symbol(char* name);
Symbol* lookup_symbol_in_module(char* name, Module* module, boolean localP);
Cons* lookup_visible_symbols_in_module(char* name, Module* module, boolean enforceshadowingP);
Surrogate* lookup_surrogate(char* name);
Surrogate* lookup_surrogate_in_module(char* name, Module* module, boolean localP);
Cons* lookup_visible_surrogates_in_module(char* name, Module* module, boolean enforceshadowingP);
Keyword* lookup_keyword(char* name);
Generalized_Symbol* help_intern_generalized_symbol(char* name, int kindofsym, Extensible_Symbol_Array* array, int offset, Module* module);
Generalized_Symbol* intern_rigid_symbol_wrt_module(char* name, Module* module, int kindofsym);
Generalized_Symbol* intern_rigid_symbol_locally(char* name, Module* module, int kindofsym);
Generalized_Symbol* intern_rigid_symbol_case_sensitively(char* name, int kindofsym, boolean tryupcasingP);
Symbol* intern_permanent_symbol(char* name);
Symbol* intern_symbol(char* name);
Symbol* intern_symbol_in_module(char* name, Module* module, boolean localP);
Symbol* intern_derived_symbol(Generalized_Symbol* basesymbol, char* newname);
Surrogate* intern_surrogate(char* name);
Surrogate* intern_surrogate_in_module(char* name, Module* module, boolean localP);
Surrogate* intern_derived_surrogate(Generalized_Symbol* basesymbol, char* newname);
Keyword* intern_keyword(char* name);
void unintern_symbol(Symbol* self);
void unintern_surrogate(Surrogate* self);
Generalized_Symbol* intern_bootstrap_symbol_at(char* name, int offset, int kindofsym);
Symbol* intern_symbol_at(char* name, int offset);
Surrogate* intern_surrogate_at(char* name, int offset);
Keyword* intern_keyword_at(char* name, int offset);
void initialize_kernel_module(Module* module, char* name, char* fullname, Module* parent);
void initialize_kernel_modules();
void initialize_symbols_and_kernel_modules();
Symbol* lookup_transient_symbol(char* name);
Symbol* intern_transient_symbol(char* name);
void free_transient_symbols();
Symbol* intern_common_lisp_symbol(char* name);
boolean symbol_common_lispP(Symbol* self);
boolean common_lisp_symbolP(Object* self);
void initialize_parsing_tables();
char* yield_gensym_name(char* prefix, int counter);
Symbol* gensym(char* prefix);
Symbol* surrogate_to_symbol(Surrogate* self);
Symbol* type_to_symbol(Surrogate* type);
Symbol* symbolize(Surrogate* surrogate);
Surrogate* string_to_surrogate(char* self);
Surrogate* symbol_to_surrogate(Symbol* self);
Surrogate* string_surrogatify(char* self);
Surrogate* typify(Object* self);
Keyword* string_keywordify(char* self);
void in_place_objects_to_symbols(Cons* conslist);
void in_place_objects_to_types(Cons* conslist);
boolean surrogate_nameP(char* name);
boolean qualified_nameP(char* name);
boolean keyword_nameP(char* name);
Generalized_Symbol* intern_generalized_symbol(char* name);
char* compute_full_name(char* name, Module* module);
boolean visible_symbolP(Symbol* self);
boolean visible_surrogateP(Surrogate* self);
Object* symbol_value(Symbol* symbol);
Object* symbol_value_setter(Symbol* symbol, Object* value);
Cons* symbol_plist(Symbol* symbol);
Cons* symbol_plist_setter(Symbol* symbol, Cons* plist);
Object* symbol_property(Symbol* symbol, Standard_Object* key);
Object* symbol_property_setter(Symbol* symbol, Object* value, Standard_Object* key);
boolean symbol_constituent_characterP(char character);
char* initialize_symbol_escape_code_table(boolean casesensitiveP);
Keyword* compute_symbol_escape_code(char* name, boolean casesensitiveP);
void print_symbol_name_readably(char* name, ostream* stream, boolean casesensitiveP);
void print_symbol(Symbol* self, ostream* stream);
void print_surrogate(Surrogate* self, ostream* stream);
void print_keyword(Keyword* self, ostream* stream);
void help_startup_symbols1();
void help_startup_symbols2();
void help_startup_symbols3();
void startup_symbols();

// Auxiliary global declarations:
extern Symbol* SYM_SYMBOLS_STELLA_MODULE_LISP_PACKAGE;
extern Symbol* SYM_SYMBOLS_STELLA_JAVA_PACKAGE;
extern Symbol* SYM_SYMBOLS_STELLA_MODULE_CPP_PACKAGE;
extern Keyword* KWD_SYMBOLS_DIGIT;
extern Keyword* KWD_SYMBOLS_LETTER;
extern Keyword* KWD_SYMBOLS_SYMBOL_CONSTITUENT;
extern Keyword* KWD_SYMBOLS_ESCAPED;
extern Keyword* KWD_SYMBOLS_UNESCAPED;
extern Keyword* KWD_SYMBOLS_SYMBOL;
extern Keyword* KWD_SYMBOLS_COMPLEX_ESCAPED;
extern Symbol* SYM_SYMBOLS_STELLA_STARTUP_SYMBOLS;
extern Symbol* SYM_SYMBOLS_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
