// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/translate-file.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/



namespace stella {

// Global declarations:
extern boolean oRECORD_SIGNATURESpo;
extern boolean oWALK_WITH_RECORDED_SIGNATURESpo;
extern DECLARE_STELLA_SPECIAL(oUSERECORDEDSIGNATURESpo, boolean );
extern DECLARE_STELLA_SPECIAL(oROOTSOURCEDIRECTORYo, char* );
extern DECLARE_STELLA_SPECIAL(oROOTNATIVEDIRECTORYo, char* );
extern DECLARE_STELLA_SPECIAL(oROOTBINARYDIRECTORYo, char* );
extern DECLARE_STELLA_SPECIAL(oSYSTEMDEFINITIONSDIRECTORYo, char* );
extern DECLARE_STELLA_SPECIAL(oCURRENTSYSTEMDEFINITIONo, System_Definition* );
extern DECLARE_STELLA_SPECIAL(oCURRENTSYSTEMDEFINITIONSUBDIRECTORYo, char* );
extern Keyword* oOSo;
extern char TYPE_SEPARATOR;
extern char LOGICAL_DIRECTORY_SEPARATOR;
extern char LOGICAL_HOST_SEPARATOR;
extern String_Hash_Table* oLOGICAL_HOST_TABLEo;
extern Cons* oTYPE_TO_FILE_EXTENSION_TABLEo;
extern char* oLISP_SPLITTER_PATHo;
extern char* oJAVA_SPLITTER_PATHo;
extern char* oCPP_SPLITTER_PATHo;
extern DECLARE_STELLA_SPECIAL(oDONTTRUNCATEFILENAMESpo, boolean );

// Function signatures:
char* root_source_directory();
char* root_native_directory();
char* root_binary_directory();
char* system_definitions_directory();
boolean handle_in_module_tree(Cons* tree, boolean seeninmoduleP, boolean& _return1);
void translate_and_output_units_to_file(char* file, char* targetlanguage);
void operate_on_file(char* file, Keyword* operation);
void clean_up_translation_units_special();
void translate_file(char* file, Keyword* outputlanguage, boolean aspartofsystemP);
void output_all_units_to_file(char* sourcefile);
void record_signatures_of_all_units(char* sourcefile);
boolean translate_with_copyright_headerP();
void output_copyright_header(Output_Stream* stream);
void output_file_header(Output_Stream* stream, char* file);
Keyword* operating_system();
char directory_separator();
char* directory_separator_string();
char directory_separator_for_file(char* file);
char* file_name_directory(char* file);
char* directory_file_name(char* directory);
char* file_name_as_directory(char* file);
char* directory_parent_directory(char* directory, int level);
char* file_name_without_directory(char* file);
char* file_name_without_extension(char* file);
char* file_extension(char* file);
char* file_base_name(char* file);
void define_logical_host_property(char* host, Keyword* property, Object* value);
Object* lookup_logical_host_property(char* host, Keyword* property);
boolean logical_hostP(char* host);
boolean logical_pathnameP(char* pathname);
boolean absolute_pathnameP(char* pathname);
char* get_logical_host_name(char* pathname);
char* logical_pathname_without_host(char* pathname);
char* translate_logical_pathname(char* pathname);
char* unlogicalize_pathname(char* pathname);
char* compute_common_lisp_file_extension(Keyword* type);
char* default_common_lisp_file_extension(Keyword* type);
char* select_file_extension(Keyword* type);
Keyword* classify_file_extension(char* file);
char* select_root_directory(Keyword* type);
char* select_splitter_path(Keyword* type);
char* make_file_name_from_relative_path(Object* filepath, Keyword* type);
char* root_directory_prefix(char* file);
char* make_file_name(char* filepath, Keyword* type, boolean relativeP);
char* relativize_file_name(char* file, char* rootpath);
char* help_implode_pathname(char* filename);
char* implode_pathname(Object* filepath);
char* maybe_truncate_filename(char* barefilename);
Keyword* language_to_file_type(Keyword* language);
char* reroot_file_name(char* file, char* fromroot, char* toroot);
Boolean_Wrapper* file_younger_thanP(char* file1, char* file2);
boolean stella_need_to_translateP(Object* file, Keyword* language);
boolean stella_need_to_compileP(Object* file);
boolean system_needs_translationP(char* systemname, Keyword* language);
Module* compute_file_units_module(List* fileunits);
List* concatenate_system_units(Key_Value_List* systemunits);
boolean translate_system(char* systemname, Keyword* outputlanguage, int options, ...);
boolean help_translate_system(Cons* files, boolean twopassP, boolean forcetranslationP);
void transfer_native_system_files(Keyword* outputlanguage);
void help_startup_translate_file1();
void help_startup_translate_file2();
void startup_translate_file();

// Auxiliary global declarations:
extern Keyword* KWD_TRANSLATE_FILE_TRANSLATE;
extern Keyword* KWD_TRANSLATE_FILE_JAVA;
extern Keyword* KWD_TRANSLATE_FILE_COMMON_LISP;
extern Keyword* KWD_TRANSLATE_FILE_CPP;
extern Keyword* KWD_TRANSLATE_FILE_CPP_STANDALONE;
extern Keyword* KWD_TRANSLATE_FILE_IDL;
extern Surrogate* SGT_TRANSLATE_FILE_STELLA_CONS;
extern Keyword* KWD_TRANSLATE_FILE_DEFINE;
extern Keyword* KWD_TRANSLATE_FILE_FINALIZE;
extern Keyword* KWD_TRANSLATE_FILE_WALK;
extern Keyword* KWD_TRANSLATE_FILE_TRANSLATE_WITH_COPYRIGHT_HEADER;
extern Keyword* KWD_TRANSLATE_FILE_WINDOWS;
extern Keyword* KWD_TRANSLATE_FILE_UNIX;
extern Keyword* KWD_TRANSLATE_FILE_MAC;
extern Keyword* KWD_TRANSLATE_FILE_ROOT_DIRECTORY;
extern Keyword* KWD_TRANSLATE_FILE_LISP_TRANSLATIONS;
extern Keyword* KWD_TRANSLATE_FILE_STELLA;
extern Keyword* KWD_TRANSLATE_FILE_KB;
extern Keyword* KWD_TRANSLATE_FILE_CPP_CODE;
extern Keyword* KWD_TRANSLATE_FILE_CPP_HEADER;
extern Keyword* KWD_TRANSLATE_FILE_NONE;
extern Keyword* KWD_TRANSLATE_FILE_USE_COMMON_LISP_STRUCTS;
extern Keyword* KWD_TRANSLATE_FILE_USE_COMMON_LISP_VECTOR_STRUCTS;
extern Keyword* KWD_TRANSLATE_FILE_LISP_BINARY;
extern Keyword* KWD_TRANSLATE_FILE_LISP;
extern Keyword* KWD_TRANSLATE_FILE_DIRECTORY;
extern Keyword* KWD_TRANSLATE_FILE_OTHER;
extern Symbol* SYM_TRANSLATE_FILE_STELLA_SYSTEM_UNITS_ALIST;
extern Symbol* SYM_TRANSLATE_FILE_STELLA_STARTUP_TIME_PROGN;
extern Symbol* SYM_TRANSLATE_FILE_STELLA_VERBATIM;
extern Keyword* KWD_TRANSLATE_FILE_TWO_PASSp;
extern Keyword* KWD_TRANSLATE_FILE_FORCE_TRANSLATIONp;
extern Keyword* KWD_TRANSLATE_FILE_PRODUCTION_SETTINGSp;
extern Keyword* KWD_TRANSLATE_FILE_DEVELOPMENT_SETTINGSp;
extern Keyword* KWD_TRANSLATE_FILE_WARN_ABOUT_MISSING_METHODS;
extern Keyword* KWD_TRANSLATE_FILE_WARN_ABOUT_UNDEFINED_METHODS;
extern Keyword* KWD_TRANSLATE_FILE_USE_HARDCODED_SYMBOLS;
extern Symbol* SYM_TRANSLATE_FILE_STELLA_STARTUP_TRANSLATE_FILE;
extern Symbol* SYM_TRANSLATE_FILE_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
